/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package tools.descartes.dml.mm.applicationlevel.functions.provider;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

import tools.descartes.dml.mm.applicationlevel.functions.util.FunctionsAdapterFactory;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class FunctionsItemProviderAdapterFactory extends FunctionsAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable {
	/**
	 * This keeps track of the root adapter factory that delegates to this adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComposedAdapterFactory parentAdapterFactory;

	/**
	 * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IChangeNotifier changeNotifier = new ChangeNotifier();

	/**
	 * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Collection<Object> supportedTypes = new ArrayList<Object>();

	/**
	 * This constructs an instance.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FunctionsItemProviderAdapterFactory() {
		supportedTypes.add(IEditingDomainItemProvider.class);
		supportedTypes.add(IStructuredItemContentProvider.class);
		supportedTypes.add(ITreeItemContentProvider.class);
		supportedTypes.add(IItemLabelProvider.class);
		supportedTypes.add(IItemPropertySource.class);
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.functions.ExplicitDescription} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ExplicitDescriptionItemProvider explicitDescriptionItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.functions.ExplicitDescription}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createExplicitDescriptionAdapter() {
		if (explicitDescriptionItemProvider == null) {
			explicitDescriptionItemProvider = new ExplicitDescriptionItemProvider(this);
		}

		return explicitDescriptionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.functions.Function} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FunctionItemProvider functionItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.functions.Function}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createFunctionAdapter() {
		if (functionItemProvider == null) {
			functionItemProvider = new FunctionItemProvider(this);
		}

		return functionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.functions.InfluencingParameterValue} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected InfluencingParameterValueItemProvider influencingParameterValueItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.functions.InfluencingParameterValue}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createInfluencingParameterValueAdapter() {
		if (influencingParameterValueItemProvider == null) {
			influencingParameterValueItemProvider = new InfluencingParameterValueItemProvider(this);
		}

		return influencingParameterValueItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.functions.IfElseExpression} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IfElseExpressionItemProvider ifElseExpressionItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.functions.IfElseExpression}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createIfElseExpressionAdapter() {
		if (ifElseExpressionItemProvider == null) {
			ifElseExpressionItemProvider = new IfElseExpressionItemProvider(this);
		}

		return ifElseExpressionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.functions.BinaryBooleanExpression} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BinaryBooleanExpressionItemProvider binaryBooleanExpressionItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.functions.BinaryBooleanExpression}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createBinaryBooleanExpressionAdapter() {
		if (binaryBooleanExpressionItemProvider == null) {
			binaryBooleanExpressionItemProvider = new BinaryBooleanExpressionItemProvider(this);
		}

		return binaryBooleanExpressionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.functions.UnaryBooleanExpression} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected UnaryBooleanExpressionItemProvider unaryBooleanExpressionItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.functions.UnaryBooleanExpression}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createUnaryBooleanExpressionAdapter() {
		if (unaryBooleanExpressionItemProvider == null) {
			unaryBooleanExpressionItemProvider = new UnaryBooleanExpressionItemProvider(this);
		}

		return unaryBooleanExpressionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.functions.Comparison} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComparisonItemProvider comparisonItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.functions.Comparison}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createComparisonAdapter() {
		if (comparisonItemProvider == null) {
			comparisonItemProvider = new ComparisonItemProvider(this);
		}

		return comparisonItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.functions.Term} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TermItemProvider termItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.functions.Term}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createTermAdapter() {
		if (termItemProvider == null) {
			termItemProvider = new TermItemProvider(this);
		}

		return termItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.functions.Product} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ProductItemProvider productItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.functions.Product}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createProductAdapter() {
		if (productItemProvider == null) {
			productItemProvider = new ProductItemProvider(this);
		}

		return productItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.functions.Power} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PowerItemProvider powerItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.functions.Power}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createPowerAdapter() {
		if (powerItemProvider == null) {
			powerItemProvider = new PowerItemProvider(this);
		}

		return powerItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.functions.RandomVariable} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RandomVariableItemProvider randomVariableItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.functions.RandomVariable}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createRandomVariableAdapter() {
		if (randomVariableItemProvider == null) {
			randomVariableItemProvider = new RandomVariableItemProvider(this);
		}

		return randomVariableItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.functions.BooleanLiteral} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BooleanLiteralItemProvider booleanLiteralItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.functions.BooleanLiteral}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createBooleanLiteralAdapter() {
		if (booleanLiteralItemProvider == null) {
			booleanLiteralItemProvider = new BooleanLiteralItemProvider(this);
		}

		return booleanLiteralItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.functions.IntLiteral} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IntLiteralItemProvider intLiteralItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.functions.IntLiteral}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createIntLiteralAdapter() {
		if (intLiteralItemProvider == null) {
			intLiteralItemProvider = new IntLiteralItemProvider(this);
		}

		return intLiteralItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.functions.DoubleLiteral} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DoubleLiteralItemProvider doubleLiteralItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.functions.DoubleLiteral}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createDoubleLiteralAdapter() {
		if (doubleLiteralItemProvider == null) {
			doubleLiteralItemProvider = new DoubleLiteralItemProvider(this);
		}

		return doubleLiteralItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.functions.ProbabilityMassFunction} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ProbabilityMassFunctionItemProvider probabilityMassFunctionItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.functions.ProbabilityMassFunction}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createProbabilityMassFunctionAdapter() {
		if (probabilityMassFunctionItemProvider == null) {
			probabilityMassFunctionItemProvider = new ProbabilityMassFunctionItemProvider(this);
		}

		return probabilityMassFunctionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.functions.DoubleSample} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DoubleSampleItemProvider doubleSampleItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.functions.DoubleSample}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createDoubleSampleAdapter() {
		if (doubleSampleItemProvider == null) {
			doubleSampleItemProvider = new DoubleSampleItemProvider(this);
		}

		return doubleSampleItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.functions.IntSample} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IntSampleItemProvider intSampleItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.functions.IntSample}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createIntSampleAdapter() {
		if (intSampleItemProvider == null) {
			intSampleItemProvider = new IntSampleItemProvider(this);
		}

		return intSampleItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.functions.BoolSample} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BoolSampleItemProvider boolSampleItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.functions.BoolSample}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createBoolSampleAdapter() {
		if (boolSampleItemProvider == null) {
			boolSampleItemProvider = new BoolSampleItemProvider(this);
		}

		return boolSampleItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.functions.EnumSample} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EnumSampleItemProvider enumSampleItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.functions.EnumSample}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createEnumSampleAdapter() {
		if (enumSampleItemProvider == null) {
			enumSampleItemProvider = new EnumSampleItemProvider(this);
		}

		return enumSampleItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.functions.IntSampleList} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IntSampleListItemProvider intSampleListItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.functions.IntSampleList}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createIntSampleListAdapter() {
		if (intSampleListItemProvider == null) {
			intSampleListItemProvider = new IntSampleListItemProvider(this);
		}

		return intSampleListItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.functions.DoubleSampleList} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DoubleSampleListItemProvider doubleSampleListItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.functions.DoubleSampleList}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createDoubleSampleListAdapter() {
		if (doubleSampleListItemProvider == null) {
			doubleSampleListItemProvider = new DoubleSampleListItemProvider(this);
		}

		return doubleSampleListItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.functions.BoolSampleList} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BoolSampleListItemProvider boolSampleListItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.functions.BoolSampleList}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createBoolSampleListAdapter() {
		if (boolSampleListItemProvider == null) {
			boolSampleListItemProvider = new BoolSampleListItemProvider(this);
		}

		return boolSampleListItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.functions.EnumSampleList} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EnumSampleListItemProvider enumSampleListItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.functions.EnumSampleList}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createEnumSampleListAdapter() {
		if (enumSampleListItemProvider == null) {
			enumSampleListItemProvider = new EnumSampleListItemProvider(this);
		}

		return enumSampleListItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.functions.ReplayFile} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ReplayFileItemProvider replayFileItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.functions.ReplayFile}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createReplayFileAdapter() {
		if (replayFileItemProvider == null) {
			replayFileItemProvider = new ReplayFileItemProvider(this);
		}

		return replayFileItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.functions.BoxedPDF} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BoxedPDFItemProvider boxedPDFItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.functions.BoxedPDF}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createBoxedPDFAdapter() {
		if (boxedPDFItemProvider == null) {
			boxedPDFItemProvider = new BoxedPDFItemProvider(this);
		}

		return boxedPDFItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.functions.ContinuousSample} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ContinuousSampleItemProvider continuousSampleItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.functions.ContinuousSample}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createContinuousSampleAdapter() {
		if (continuousSampleItemProvider == null) {
			continuousSampleItemProvider = new ContinuousSampleItemProvider(this);
		}

		return continuousSampleItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.functions.NormalDistribution} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected NormalDistributionItemProvider normalDistributionItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.functions.NormalDistribution}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createNormalDistributionAdapter() {
		if (normalDistributionItemProvider == null) {
			normalDistributionItemProvider = new NormalDistributionItemProvider(this);
		}

		return normalDistributionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.functions.ExponentialDistribution} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ExponentialDistributionItemProvider exponentialDistributionItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.functions.ExponentialDistribution}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createExponentialDistributionAdapter() {
		if (exponentialDistributionItemProvider == null) {
			exponentialDistributionItemProvider = new ExponentialDistributionItemProvider(this);
		}

		return exponentialDistributionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.functions.EmpiricalDescription} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EmpiricalDescriptionItemProvider empiricalDescriptionItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.functions.EmpiricalDescription}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createEmpiricalDescriptionAdapter() {
		if (empiricalDescriptionItemProvider == null) {
			empiricalDescriptionItemProvider = new EmpiricalDescriptionItemProvider(this);
		}

		return empiricalDescriptionItemProvider;
	}

	/**
	 * This returns the root adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ComposeableAdapterFactory getRootAdapterFactory() {
		return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
	}

	/**
	 * This sets the composed adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory) {
		this.parentAdapterFactory = parentAdapterFactory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object type) {
		return supportedTypes.contains(type) || super.isFactoryForType(type);
	}

	/**
	 * This implementation substitutes the factory itself as the key for the adapter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter adapt(Notifier notifier, Object type) {
		return super.adapt(notifier, this);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object adapt(Object object, Object type) {
		if (isFactoryForType(type)) {
			Object adapter = super.adapt(object, type);
			if (!(type instanceof Class<?>) || (((Class<?>)type).isInstance(adapter))) {
				return adapter;
			}
		}

		return null;
	}

	/**
	 * This adds a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void addListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.addListener(notifyChangedListener);
	}

	/**
	 * This removes a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void removeListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.removeListener(notifyChangedListener);
	}

	/**
	 * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void fireNotifyChanged(Notification notification) {
		changeNotifier.fireNotifyChanged(notification);

		if (parentAdapterFactory != null) {
			parentAdapterFactory.fireNotifyChanged(notification);
		}
	}

	/**
	 * This disposes all of the item providers created by this factory. 
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void dispose() {
		if (explicitDescriptionItemProvider != null) explicitDescriptionItemProvider.dispose();
		if (functionItemProvider != null) functionItemProvider.dispose();
		if (influencingParameterValueItemProvider != null) influencingParameterValueItemProvider.dispose();
		if (ifElseExpressionItemProvider != null) ifElseExpressionItemProvider.dispose();
		if (binaryBooleanExpressionItemProvider != null) binaryBooleanExpressionItemProvider.dispose();
		if (unaryBooleanExpressionItemProvider != null) unaryBooleanExpressionItemProvider.dispose();
		if (comparisonItemProvider != null) comparisonItemProvider.dispose();
		if (termItemProvider != null) termItemProvider.dispose();
		if (productItemProvider != null) productItemProvider.dispose();
		if (powerItemProvider != null) powerItemProvider.dispose();
		if (randomVariableItemProvider != null) randomVariableItemProvider.dispose();
		if (booleanLiteralItemProvider != null) booleanLiteralItemProvider.dispose();
		if (intLiteralItemProvider != null) intLiteralItemProvider.dispose();
		if (doubleLiteralItemProvider != null) doubleLiteralItemProvider.dispose();
		if (probabilityMassFunctionItemProvider != null) probabilityMassFunctionItemProvider.dispose();
		if (doubleSampleItemProvider != null) doubleSampleItemProvider.dispose();
		if (intSampleItemProvider != null) intSampleItemProvider.dispose();
		if (boolSampleItemProvider != null) boolSampleItemProvider.dispose();
		if (enumSampleItemProvider != null) enumSampleItemProvider.dispose();
		if (intSampleListItemProvider != null) intSampleListItemProvider.dispose();
		if (doubleSampleListItemProvider != null) doubleSampleListItemProvider.dispose();
		if (boolSampleListItemProvider != null) boolSampleListItemProvider.dispose();
		if (enumSampleListItemProvider != null) enumSampleListItemProvider.dispose();
		if (replayFileItemProvider != null) replayFileItemProvider.dispose();
		if (boxedPDFItemProvider != null) boxedPDFItemProvider.dispose();
		if (continuousSampleItemProvider != null) continuousSampleItemProvider.dispose();
		if (normalDistributionItemProvider != null) normalDistributionItemProvider.dispose();
		if (exponentialDistributionItemProvider != null) exponentialDistributionItemProvider.dispose();
		if (empiricalDescriptionItemProvider != null) empiricalDescriptionItemProvider.dispose();
	}

}
