/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package tools.descartes.dml.mm.applicationlevel.parameterdependencies;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

import tools.descartes.dml.identifier.IdentifierPackage;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.ServicebehaviorPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.ParameterdependenciesFactory
 * @model kind="package"
 *        annotation="http://www.eclipse.org/OCL/Import core_0='../../tools.descartes.dml.core/model/core.ecore#/' ecore_0='http://www.eclipse.org/emf/2002/Ecore' functions_0='functions.ecore#/' identifier='../../tools.descartes.dml.identifier/model/identifier.ecore#/' repository_0='repository.ecore#/' servicebehavior_0='servicebehavior.ecore#/'"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore invocationDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot' settingDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot' validationDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot'"
 * @generated
 */
public interface ParameterdependenciesPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "parameterdependencies";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.descartes.tools/metamodel/parameterdependencies/1.0";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "parameterdependencies";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	ParameterdependenciesPackage eINSTANCE = tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl.init();

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ModelVariableImpl <em>Model Variable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ModelVariableImpl
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getModelVariable()
	 * @generated
	 */
	int MODEL_VARIABLE = 0;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_VARIABLE__ID = IdentifierPackage.IDENTIFIER__ID;

	/**
	 * The feature id for the '<em><b>Scope Set</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_VARIABLE__SCOPE_SET = IdentifierPackage.IDENTIFIER_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Model Variable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_VARIABLE_FEATURE_COUNT = IdentifierPackage.IDENTIFIER_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ScopeSetImpl <em>Scope Set</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ScopeSetImpl
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getScopeSet()
	 * @generated
	 */
	int SCOPE_SET = 1;

	/**
	 * The feature id for the '<em><b>Scope</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCOPE_SET__SCOPE = 0;

	/**
	 * The number of structural features of the '<em>Scope Set</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCOPE_SET_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ScopeImpl <em>Scope</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ScopeImpl
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getScope()
	 * @generated
	 */
	int SCOPE = 2;

	/**
	 * The feature id for the '<em><b>Scope</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCOPE__SCOPE = 0;

	/**
	 * The number of structural features of the '<em>Scope</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCOPE_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.InfluencableModelVariable <em>Influencable Model Variable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.InfluencableModelVariable
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getInfluencableModelVariable()
	 * @generated
	 */
	int INFLUENCABLE_MODEL_VARIABLE = 14;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ControlFlowVariableImpl <em>Control Flow Variable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ControlFlowVariableImpl
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getControlFlowVariable()
	 * @generated
	 */
	int CONTROL_FLOW_VARIABLE = 3;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_FLOW_VARIABLE__ID = ServicebehaviorPackage.RELATIONSHIP_VARIABLE__ID;

	/**
	 * The feature id for the '<em><b>Scope Set</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_FLOW_VARIABLE__SCOPE_SET = ServicebehaviorPackage.RELATIONSHIP_VARIABLE__SCOPE_SET;

	/**
	 * The feature id for the '<em><b>Characterization</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_FLOW_VARIABLE__CHARACTERIZATION = ServicebehaviorPackage.RELATIONSHIP_VARIABLE__CHARACTERIZATION;

	/**
	 * The feature id for the '<em><b>Explicit Description</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_FLOW_VARIABLE__EXPLICIT_DESCRIPTION = ServicebehaviorPackage.RELATIONSHIP_VARIABLE__EXPLICIT_DESCRIPTION;

	/**
	 * The number of structural features of the '<em>Control Flow Variable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_FLOW_VARIABLE_FEATURE_COUNT = ServicebehaviorPackage.RELATIONSHIP_VARIABLE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ShadowParameterImpl <em>Shadow Parameter</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ShadowParameterImpl
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getShadowParameter()
	 * @generated
	 */
	int SHADOW_PARAMETER = 4;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SHADOW_PARAMETER__ID = ServicebehaviorPackage.RELATIONSHIP_VARIABLE__ID;

	/**
	 * The feature id for the '<em><b>Scope Set</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SHADOW_PARAMETER__SCOPE_SET = ServicebehaviorPackage.RELATIONSHIP_VARIABLE__SCOPE_SET;

	/**
	 * The feature id for the '<em><b>Characterization</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SHADOW_PARAMETER__CHARACTERIZATION = ServicebehaviorPackage.RELATIONSHIP_VARIABLE__CHARACTERIZATION;

	/**
	 * The feature id for the '<em><b>Explicit Description</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SHADOW_PARAMETER__EXPLICIT_DESCRIPTION = ServicebehaviorPackage.RELATIONSHIP_VARIABLE__EXPLICIT_DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SHADOW_PARAMETER__NAME = ServicebehaviorPackage.RELATIONSHIP_VARIABLE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SHADOW_PARAMETER__DESCRIPTION = ServicebehaviorPackage.RELATIONSHIP_VARIABLE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Shadow Parameter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SHADOW_PARAMETER_FEATURE_COUNT = ServicebehaviorPackage.RELATIONSHIP_VARIABLE_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.RelationshipImpl <em>Relationship</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.RelationshipImpl
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getRelationship()
	 * @generated
	 */
	int RELATIONSHIP = 5;

	/**
	 * The feature id for the '<em><b>Empirical Description</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP__EMPIRICAL_DESCRIPTION = 0;

	/**
	 * The feature id for the '<em><b>Explicit Description</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP__EXPLICIT_DESCRIPTION = 1;

	/**
	 * The feature id for the '<em><b>Characterization</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP__CHARACTERIZATION = 2;

	/**
	 * The feature id for the '<em><b>Dependent</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP__DEPENDENT = 3;

	/**
	 * The feature id for the '<em><b>Independent</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP__INDEPENDENT = 4;

	/**
	 * The number of structural features of the '<em>Relationship</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_FEATURE_COUNT = 5;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.DependencyRelationshipImpl <em>Dependency Relationship</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.DependencyRelationshipImpl
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getDependencyRelationship()
	 * @generated
	 */
	int DEPENDENCY_RELATIONSHIP = 6;

	/**
	 * The feature id for the '<em><b>Empirical Description</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_RELATIONSHIP__EMPIRICAL_DESCRIPTION = RELATIONSHIP__EMPIRICAL_DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Explicit Description</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_RELATIONSHIP__EXPLICIT_DESCRIPTION = RELATIONSHIP__EXPLICIT_DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Characterization</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_RELATIONSHIP__CHARACTERIZATION = RELATIONSHIP__CHARACTERIZATION;

	/**
	 * The feature id for the '<em><b>Dependent</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_RELATIONSHIP__DEPENDENT = RELATIONSHIP__DEPENDENT;

	/**
	 * The feature id for the '<em><b>Independent</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_RELATIONSHIP__INDEPENDENT = RELATIONSHIP__INDEPENDENT;

	/**
	 * The number of structural features of the '<em>Dependency Relationship</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_RELATIONSHIP_FEATURE_COUNT = RELATIONSHIP_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.DependencyPropagationRelationshipImpl <em>Dependency Propagation Relationship</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.DependencyPropagationRelationshipImpl
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getDependencyPropagationRelationship()
	 * @generated
	 */
	int DEPENDENCY_PROPAGATION_RELATIONSHIP = 7;

	/**
	 * The feature id for the '<em><b>Empirical Description</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_PROPAGATION_RELATIONSHIP__EMPIRICAL_DESCRIPTION = RELATIONSHIP__EMPIRICAL_DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Explicit Description</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_PROPAGATION_RELATIONSHIP__EXPLICIT_DESCRIPTION = RELATIONSHIP__EXPLICIT_DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Characterization</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_PROPAGATION_RELATIONSHIP__CHARACTERIZATION = RELATIONSHIP__CHARACTERIZATION;

	/**
	 * The feature id for the '<em><b>Dependent</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_PROPAGATION_RELATIONSHIP__DEPENDENT = RELATIONSHIP__DEPENDENT;

	/**
	 * The feature id for the '<em><b>Independent</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_PROPAGATION_RELATIONSHIP__INDEPENDENT = RELATIONSHIP__INDEPENDENT;

	/**
	 * The feature id for the '<em><b>Independent Component Instance References</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_PROPAGATION_RELATIONSHIP__INDEPENDENT_COMPONENT_INSTANCE_REFERENCES = RELATIONSHIP_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Dependent Component Instance Reference</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_PROPAGATION_RELATIONSHIP__DEPENDENT_COMPONENT_INSTANCE_REFERENCE = RELATIONSHIP_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Dependency Propagation Relationship</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_PROPAGATION_RELATIONSHIP_FEATURE_COUNT = RELATIONSHIP_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ComponentInstanceReferenceImpl <em>Component Instance Reference</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ComponentInstanceReferenceImpl
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getComponentInstanceReference()
	 * @generated
	 */
	int COMPONENT_INSTANCE_REFERENCE = 8;

	/**
	 * The feature id for the '<em><b>Assemblies</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_INSTANCE_REFERENCE__ASSEMBLIES = 0;

	/**
	 * The number of structural features of the '<em>Component Instance Reference</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_INSTANCE_REFERENCE_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.CallParameterImpl <em>Call Parameter</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.CallParameterImpl
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getCallParameter()
	 * @generated
	 */
	int CALL_PARAMETER = 9;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_PARAMETER__ID = ServicebehaviorPackage.RELATIONSHIP_VARIABLE__ID;

	/**
	 * The feature id for the '<em><b>Scope Set</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_PARAMETER__SCOPE_SET = ServicebehaviorPackage.RELATIONSHIP_VARIABLE__SCOPE_SET;

	/**
	 * The feature id for the '<em><b>Characterization</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_PARAMETER__CHARACTERIZATION = ServicebehaviorPackage.RELATIONSHIP_VARIABLE__CHARACTERIZATION;

	/**
	 * The feature id for the '<em><b>Explicit Description</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_PARAMETER__EXPLICIT_DESCRIPTION = ServicebehaviorPackage.RELATIONSHIP_VARIABLE__EXPLICIT_DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Parameter Characterization</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_PARAMETER__PARAMETER_CHARACTERIZATION = ServicebehaviorPackage.RELATIONSHIP_VARIABLE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Call Parameter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_PARAMETER_FEATURE_COUNT = ServicebehaviorPackage.RELATIONSHIP_VARIABLE_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ServiceInputParameterImpl <em>Service Input Parameter</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ServiceInputParameterImpl
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getServiceInputParameter()
	 * @generated
	 */
	int SERVICE_INPUT_PARAMETER = 10;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_INPUT_PARAMETER__ID = CALL_PARAMETER__ID;

	/**
	 * The feature id for the '<em><b>Scope Set</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_INPUT_PARAMETER__SCOPE_SET = CALL_PARAMETER__SCOPE_SET;

	/**
	 * The feature id for the '<em><b>Characterization</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_INPUT_PARAMETER__CHARACTERIZATION = CALL_PARAMETER__CHARACTERIZATION;

	/**
	 * The feature id for the '<em><b>Explicit Description</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_INPUT_PARAMETER__EXPLICIT_DESCRIPTION = CALL_PARAMETER__EXPLICIT_DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Parameter Characterization</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_INPUT_PARAMETER__PARAMETER_CHARACTERIZATION = CALL_PARAMETER__PARAMETER_CHARACTERIZATION;

	/**
	 * The feature id for the '<em><b>Providing Role</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_INPUT_PARAMETER__PROVIDING_ROLE = CALL_PARAMETER_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Parameter</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_INPUT_PARAMETER__PARAMETER = CALL_PARAMETER_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Service Input Parameter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_INPUT_PARAMETER_FEATURE_COUNT = CALL_PARAMETER_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ServiceOutputParameterImpl <em>Service Output Parameter</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ServiceOutputParameterImpl
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getServiceOutputParameter()
	 * @generated
	 */
	int SERVICE_OUTPUT_PARAMETER = 11;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_OUTPUT_PARAMETER__ID = CALL_PARAMETER__ID;

	/**
	 * The feature id for the '<em><b>Scope Set</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_OUTPUT_PARAMETER__SCOPE_SET = CALL_PARAMETER__SCOPE_SET;

	/**
	 * The feature id for the '<em><b>Characterization</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_OUTPUT_PARAMETER__CHARACTERIZATION = CALL_PARAMETER__CHARACTERIZATION;

	/**
	 * The feature id for the '<em><b>Explicit Description</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_OUTPUT_PARAMETER__EXPLICIT_DESCRIPTION = CALL_PARAMETER__EXPLICIT_DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Parameter Characterization</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_OUTPUT_PARAMETER__PARAMETER_CHARACTERIZATION = CALL_PARAMETER__PARAMETER_CHARACTERIZATION;

	/**
	 * The feature id for the '<em><b>Providing Role</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_OUTPUT_PARAMETER__PROVIDING_ROLE = CALL_PARAMETER_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Parameter</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_OUTPUT_PARAMETER__PARAMETER = CALL_PARAMETER_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Service Output Parameter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_OUTPUT_PARAMETER_FEATURE_COUNT = CALL_PARAMETER_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ExternalCallReturnParameterImpl <em>External Call Return Parameter</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ExternalCallReturnParameterImpl
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getExternalCallReturnParameter()
	 * @generated
	 */
	int EXTERNAL_CALL_RETURN_PARAMETER = 12;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_CALL_RETURN_PARAMETER__ID = CALL_PARAMETER__ID;

	/**
	 * The feature id for the '<em><b>Scope Set</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_CALL_RETURN_PARAMETER__SCOPE_SET = CALL_PARAMETER__SCOPE_SET;

	/**
	 * The feature id for the '<em><b>Characterization</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_CALL_RETURN_PARAMETER__CHARACTERIZATION = CALL_PARAMETER__CHARACTERIZATION;

	/**
	 * The feature id for the '<em><b>Explicit Description</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_CALL_RETURN_PARAMETER__EXPLICIT_DESCRIPTION = CALL_PARAMETER__EXPLICIT_DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Parameter Characterization</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_CALL_RETURN_PARAMETER__PARAMETER_CHARACTERIZATION = CALL_PARAMETER__PARAMETER_CHARACTERIZATION;

	/**
	 * The feature id for the '<em><b>External Call</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_CALL_RETURN_PARAMETER__EXTERNAL_CALL = CALL_PARAMETER_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Parameter</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_CALL_RETURN_PARAMETER__PARAMETER = CALL_PARAMETER_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>External Call Return Parameter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_CALL_RETURN_PARAMETER_FEATURE_COUNT = CALL_PARAMETER_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ExternalCallParameterImpl <em>External Call Parameter</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ExternalCallParameterImpl
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getExternalCallParameter()
	 * @generated
	 */
	int EXTERNAL_CALL_PARAMETER = 13;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_CALL_PARAMETER__ID = CALL_PARAMETER__ID;

	/**
	 * The feature id for the '<em><b>Scope Set</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_CALL_PARAMETER__SCOPE_SET = CALL_PARAMETER__SCOPE_SET;

	/**
	 * The feature id for the '<em><b>Characterization</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_CALL_PARAMETER__CHARACTERIZATION = CALL_PARAMETER__CHARACTERIZATION;

	/**
	 * The feature id for the '<em><b>Explicit Description</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_CALL_PARAMETER__EXPLICIT_DESCRIPTION = CALL_PARAMETER__EXPLICIT_DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Parameter Characterization</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_CALL_PARAMETER__PARAMETER_CHARACTERIZATION = CALL_PARAMETER__PARAMETER_CHARACTERIZATION;

	/**
	 * The feature id for the '<em><b>External Call</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_CALL_PARAMETER__EXTERNAL_CALL = CALL_PARAMETER_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Parameter</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_CALL_PARAMETER__PARAMETER = CALL_PARAMETER_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>External Call Parameter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_CALL_PARAMETER_FEATURE_COUNT = CALL_PARAMETER_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INFLUENCABLE_MODEL_VARIABLE__ID = MODEL_VARIABLE__ID;

	/**
	 * The feature id for the '<em><b>Scope Set</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INFLUENCABLE_MODEL_VARIABLE__SCOPE_SET = MODEL_VARIABLE__SCOPE_SET;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INFLUENCABLE_MODEL_VARIABLE__NAME = MODEL_VARIABLE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Influencable Model Variable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INFLUENCABLE_MODEL_VARIABLE_FEATURE_COUNT = MODEL_VARIABLE_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.ModelVariableCharacterizationType <em>Model Variable Characterization Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.ModelVariableCharacterizationType
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getModelVariableCharacterizationType()
	 * @generated
	 */
	int MODEL_VARIABLE_CHARACTERIZATION_TYPE = 15;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.RelationshipCharacterizationType <em>Relationship Characterization Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.RelationshipCharacterizationType
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getRelationshipCharacterizationType()
	 * @generated
	 */
	int RELATIONSHIP_CHARACTERIZATION_TYPE = 16;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.ParameterCharacterizationType <em>Parameter Characterization Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.ParameterCharacterizationType
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getParameterCharacterizationType()
	 * @generated
	 */
	int PARAMETER_CHARACTERIZATION_TYPE = 17;


	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.ModelVariable <em>Model Variable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Model Variable</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.ModelVariable
	 * @generated
	 */
	EClass getModelVariable();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.ModelVariable#getScopeSet <em>Scope Set</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Scope Set</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.ModelVariable#getScopeSet()
	 * @see #getModelVariable()
	 * @generated
	 */
	EReference getModelVariable_ScopeSet();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.ScopeSet <em>Scope Set</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Scope Set</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.ScopeSet
	 * @generated
	 */
	EClass getScopeSet();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.ScopeSet#getScope <em>Scope</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Scope</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.ScopeSet#getScope()
	 * @see #getScopeSet()
	 * @generated
	 */
	EReference getScopeSet_Scope();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.Scope <em>Scope</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Scope</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.Scope
	 * @generated
	 */
	EClass getScope();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.Scope#getScope <em>Scope</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Scope</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.Scope#getScope()
	 * @see #getScope()
	 * @generated
	 */
	EReference getScope_Scope();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.ControlFlowVariable <em>Control Flow Variable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Control Flow Variable</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.ControlFlowVariable
	 * @generated
	 */
	EClass getControlFlowVariable();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.ShadowParameter <em>Shadow Parameter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Shadow Parameter</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.ShadowParameter
	 * @generated
	 */
	EClass getShadowParameter();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.ShadowParameter#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.ShadowParameter#getName()
	 * @see #getShadowParameter()
	 * @generated
	 */
	EAttribute getShadowParameter_Name();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.ShadowParameter#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.ShadowParameter#getDescription()
	 * @see #getShadowParameter()
	 * @generated
	 */
	EAttribute getShadowParameter_Description();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.Relationship <em>Relationship</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Relationship</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.Relationship
	 * @generated
	 */
	EClass getRelationship();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.Relationship#getEmpiricalDescription <em>Empirical Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Empirical Description</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.Relationship#getEmpiricalDescription()
	 * @see #getRelationship()
	 * @generated
	 */
	EReference getRelationship_EmpiricalDescription();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.Relationship#getExplicitDescription <em>Explicit Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Explicit Description</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.Relationship#getExplicitDescription()
	 * @see #getRelationship()
	 * @generated
	 */
	EReference getRelationship_ExplicitDescription();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.Relationship#getCharacterization <em>Characterization</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Characterization</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.Relationship#getCharacterization()
	 * @see #getRelationship()
	 * @generated
	 */
	EAttribute getRelationship_Characterization();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.Relationship#getDependent <em>Dependent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Dependent</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.Relationship#getDependent()
	 * @see #getRelationship()
	 * @generated
	 */
	EReference getRelationship_Dependent();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.Relationship#getIndependent <em>Independent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Independent</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.Relationship#getIndependent()
	 * @see #getRelationship()
	 * @generated
	 */
	EReference getRelationship_Independent();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.DependencyRelationship <em>Dependency Relationship</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Dependency Relationship</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.DependencyRelationship
	 * @generated
	 */
	EClass getDependencyRelationship();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.DependencyPropagationRelationship <em>Dependency Propagation Relationship</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Dependency Propagation Relationship</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.DependencyPropagationRelationship
	 * @generated
	 */
	EClass getDependencyPropagationRelationship();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.DependencyPropagationRelationship#getIndependentComponentInstanceReferences <em>Independent Component Instance References</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Independent Component Instance References</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.DependencyPropagationRelationship#getIndependentComponentInstanceReferences()
	 * @see #getDependencyPropagationRelationship()
	 * @generated
	 */
	EReference getDependencyPropagationRelationship_IndependentComponentInstanceReferences();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.DependencyPropagationRelationship#getDependentComponentInstanceReference <em>Dependent Component Instance Reference</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Dependent Component Instance Reference</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.DependencyPropagationRelationship#getDependentComponentInstanceReference()
	 * @see #getDependencyPropagationRelationship()
	 * @generated
	 */
	EReference getDependencyPropagationRelationship_DependentComponentInstanceReference();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.ComponentInstanceReference <em>Component Instance Reference</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Component Instance Reference</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.ComponentInstanceReference
	 * @generated
	 */
	EClass getComponentInstanceReference();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.ComponentInstanceReference#getAssemblies <em>Assemblies</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Assemblies</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.ComponentInstanceReference#getAssemblies()
	 * @see #getComponentInstanceReference()
	 * @generated
	 */
	EReference getComponentInstanceReference_Assemblies();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.CallParameter <em>Call Parameter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Call Parameter</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.CallParameter
	 * @generated
	 */
	EClass getCallParameter();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.CallParameter#getParameterCharacterization <em>Parameter Characterization</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Parameter Characterization</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.CallParameter#getParameterCharacterization()
	 * @see #getCallParameter()
	 * @generated
	 */
	EAttribute getCallParameter_ParameterCharacterization();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.ServiceInputParameter <em>Service Input Parameter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Service Input Parameter</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.ServiceInputParameter
	 * @generated
	 */
	EClass getServiceInputParameter();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.ServiceInputParameter#getProvidingRole <em>Providing Role</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Providing Role</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.ServiceInputParameter#getProvidingRole()
	 * @see #getServiceInputParameter()
	 * @generated
	 */
	EReference getServiceInputParameter_ProvidingRole();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.ServiceInputParameter#getParameter <em>Parameter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Parameter</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.ServiceInputParameter#getParameter()
	 * @see #getServiceInputParameter()
	 * @generated
	 */
	EReference getServiceInputParameter_Parameter();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.ServiceOutputParameter <em>Service Output Parameter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Service Output Parameter</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.ServiceOutputParameter
	 * @generated
	 */
	EClass getServiceOutputParameter();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.ServiceOutputParameter#getProvidingRole <em>Providing Role</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Providing Role</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.ServiceOutputParameter#getProvidingRole()
	 * @see #getServiceOutputParameter()
	 * @generated
	 */
	EReference getServiceOutputParameter_ProvidingRole();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.ServiceOutputParameter#getParameter <em>Parameter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Parameter</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.ServiceOutputParameter#getParameter()
	 * @see #getServiceOutputParameter()
	 * @generated
	 */
	EReference getServiceOutputParameter_Parameter();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.ExternalCallReturnParameter <em>External Call Return Parameter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>External Call Return Parameter</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.ExternalCallReturnParameter
	 * @generated
	 */
	EClass getExternalCallReturnParameter();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.ExternalCallReturnParameter#getExternalCall <em>External Call</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>External Call</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.ExternalCallReturnParameter#getExternalCall()
	 * @see #getExternalCallReturnParameter()
	 * @generated
	 */
	EReference getExternalCallReturnParameter_ExternalCall();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.ExternalCallReturnParameter#getParameter <em>Parameter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Parameter</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.ExternalCallReturnParameter#getParameter()
	 * @see #getExternalCallReturnParameter()
	 * @generated
	 */
	EReference getExternalCallReturnParameter_Parameter();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.ExternalCallParameter <em>External Call Parameter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>External Call Parameter</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.ExternalCallParameter
	 * @generated
	 */
	EClass getExternalCallParameter();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.ExternalCallParameter#getExternalCall <em>External Call</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>External Call</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.ExternalCallParameter#getExternalCall()
	 * @see #getExternalCallParameter()
	 * @generated
	 */
	EReference getExternalCallParameter_ExternalCall();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.ExternalCallParameter#getParameter <em>Parameter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Parameter</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.ExternalCallParameter#getParameter()
	 * @see #getExternalCallParameter()
	 * @generated
	 */
	EReference getExternalCallParameter_Parameter();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.InfluencableModelVariable <em>Influencable Model Variable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Influencable Model Variable</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.InfluencableModelVariable
	 * @generated
	 */
	EClass getInfluencableModelVariable();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.InfluencableModelVariable#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.InfluencableModelVariable#getName()
	 * @see #getInfluencableModelVariable()
	 * @generated
	 */
	EAttribute getInfluencableModelVariable_Name();

	/**
	 * Returns the meta object for enum '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.ModelVariableCharacterizationType <em>Model Variable Characterization Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Model Variable Characterization Type</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.ModelVariableCharacterizationType
	 * @generated
	 */
	EEnum getModelVariableCharacterizationType();

	/**
	 * Returns the meta object for enum '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.RelationshipCharacterizationType <em>Relationship Characterization Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Relationship Characterization Type</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.RelationshipCharacterizationType
	 * @generated
	 */
	EEnum getRelationshipCharacterizationType();

	/**
	 * Returns the meta object for enum '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.ParameterCharacterizationType <em>Parameter Characterization Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Parameter Characterization Type</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.ParameterCharacterizationType
	 * @generated
	 */
	EEnum getParameterCharacterizationType();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	ParameterdependenciesFactory getParameterdependenciesFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ModelVariableImpl <em>Model Variable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ModelVariableImpl
		 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getModelVariable()
		 * @generated
		 */
		EClass MODEL_VARIABLE = eINSTANCE.getModelVariable();

		/**
		 * The meta object literal for the '<em><b>Scope Set</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL_VARIABLE__SCOPE_SET = eINSTANCE.getModelVariable_ScopeSet();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ScopeSetImpl <em>Scope Set</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ScopeSetImpl
		 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getScopeSet()
		 * @generated
		 */
		EClass SCOPE_SET = eINSTANCE.getScopeSet();

		/**
		 * The meta object literal for the '<em><b>Scope</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SCOPE_SET__SCOPE = eINSTANCE.getScopeSet_Scope();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ScopeImpl <em>Scope</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ScopeImpl
		 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getScope()
		 * @generated
		 */
		EClass SCOPE = eINSTANCE.getScope();

		/**
		 * The meta object literal for the '<em><b>Scope</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SCOPE__SCOPE = eINSTANCE.getScope_Scope();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ControlFlowVariableImpl <em>Control Flow Variable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ControlFlowVariableImpl
		 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getControlFlowVariable()
		 * @generated
		 */
		EClass CONTROL_FLOW_VARIABLE = eINSTANCE.getControlFlowVariable();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ShadowParameterImpl <em>Shadow Parameter</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ShadowParameterImpl
		 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getShadowParameter()
		 * @generated
		 */
		EClass SHADOW_PARAMETER = eINSTANCE.getShadowParameter();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SHADOW_PARAMETER__NAME = eINSTANCE.getShadowParameter_Name();

		/**
		 * The meta object literal for the '<em><b>Description</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SHADOW_PARAMETER__DESCRIPTION = eINSTANCE.getShadowParameter_Description();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.RelationshipImpl <em>Relationship</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.RelationshipImpl
		 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getRelationship()
		 * @generated
		 */
		EClass RELATIONSHIP = eINSTANCE.getRelationship();

		/**
		 * The meta object literal for the '<em><b>Empirical Description</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RELATIONSHIP__EMPIRICAL_DESCRIPTION = eINSTANCE.getRelationship_EmpiricalDescription();

		/**
		 * The meta object literal for the '<em><b>Explicit Description</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RELATIONSHIP__EXPLICIT_DESCRIPTION = eINSTANCE.getRelationship_ExplicitDescription();

		/**
		 * The meta object literal for the '<em><b>Characterization</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RELATIONSHIP__CHARACTERIZATION = eINSTANCE.getRelationship_Characterization();

		/**
		 * The meta object literal for the '<em><b>Dependent</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RELATIONSHIP__DEPENDENT = eINSTANCE.getRelationship_Dependent();

		/**
		 * The meta object literal for the '<em><b>Independent</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RELATIONSHIP__INDEPENDENT = eINSTANCE.getRelationship_Independent();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.DependencyRelationshipImpl <em>Dependency Relationship</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.DependencyRelationshipImpl
		 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getDependencyRelationship()
		 * @generated
		 */
		EClass DEPENDENCY_RELATIONSHIP = eINSTANCE.getDependencyRelationship();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.DependencyPropagationRelationshipImpl <em>Dependency Propagation Relationship</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.DependencyPropagationRelationshipImpl
		 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getDependencyPropagationRelationship()
		 * @generated
		 */
		EClass DEPENDENCY_PROPAGATION_RELATIONSHIP = eINSTANCE.getDependencyPropagationRelationship();

		/**
		 * The meta object literal for the '<em><b>Independent Component Instance References</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DEPENDENCY_PROPAGATION_RELATIONSHIP__INDEPENDENT_COMPONENT_INSTANCE_REFERENCES = eINSTANCE.getDependencyPropagationRelationship_IndependentComponentInstanceReferences();

		/**
		 * The meta object literal for the '<em><b>Dependent Component Instance Reference</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DEPENDENCY_PROPAGATION_RELATIONSHIP__DEPENDENT_COMPONENT_INSTANCE_REFERENCE = eINSTANCE.getDependencyPropagationRelationship_DependentComponentInstanceReference();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ComponentInstanceReferenceImpl <em>Component Instance Reference</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ComponentInstanceReferenceImpl
		 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getComponentInstanceReference()
		 * @generated
		 */
		EClass COMPONENT_INSTANCE_REFERENCE = eINSTANCE.getComponentInstanceReference();

		/**
		 * The meta object literal for the '<em><b>Assemblies</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COMPONENT_INSTANCE_REFERENCE__ASSEMBLIES = eINSTANCE.getComponentInstanceReference_Assemblies();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.CallParameterImpl <em>Call Parameter</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.CallParameterImpl
		 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getCallParameter()
		 * @generated
		 */
		EClass CALL_PARAMETER = eINSTANCE.getCallParameter();

		/**
		 * The meta object literal for the '<em><b>Parameter Characterization</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CALL_PARAMETER__PARAMETER_CHARACTERIZATION = eINSTANCE.getCallParameter_ParameterCharacterization();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ServiceInputParameterImpl <em>Service Input Parameter</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ServiceInputParameterImpl
		 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getServiceInputParameter()
		 * @generated
		 */
		EClass SERVICE_INPUT_PARAMETER = eINSTANCE.getServiceInputParameter();

		/**
		 * The meta object literal for the '<em><b>Providing Role</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SERVICE_INPUT_PARAMETER__PROVIDING_ROLE = eINSTANCE.getServiceInputParameter_ProvidingRole();

		/**
		 * The meta object literal for the '<em><b>Parameter</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SERVICE_INPUT_PARAMETER__PARAMETER = eINSTANCE.getServiceInputParameter_Parameter();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ServiceOutputParameterImpl <em>Service Output Parameter</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ServiceOutputParameterImpl
		 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getServiceOutputParameter()
		 * @generated
		 */
		EClass SERVICE_OUTPUT_PARAMETER = eINSTANCE.getServiceOutputParameter();

		/**
		 * The meta object literal for the '<em><b>Providing Role</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SERVICE_OUTPUT_PARAMETER__PROVIDING_ROLE = eINSTANCE.getServiceOutputParameter_ProvidingRole();

		/**
		 * The meta object literal for the '<em><b>Parameter</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SERVICE_OUTPUT_PARAMETER__PARAMETER = eINSTANCE.getServiceOutputParameter_Parameter();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ExternalCallReturnParameterImpl <em>External Call Return Parameter</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ExternalCallReturnParameterImpl
		 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getExternalCallReturnParameter()
		 * @generated
		 */
		EClass EXTERNAL_CALL_RETURN_PARAMETER = eINSTANCE.getExternalCallReturnParameter();

		/**
		 * The meta object literal for the '<em><b>External Call</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EXTERNAL_CALL_RETURN_PARAMETER__EXTERNAL_CALL = eINSTANCE.getExternalCallReturnParameter_ExternalCall();

		/**
		 * The meta object literal for the '<em><b>Parameter</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EXTERNAL_CALL_RETURN_PARAMETER__PARAMETER = eINSTANCE.getExternalCallReturnParameter_Parameter();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ExternalCallParameterImpl <em>External Call Parameter</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ExternalCallParameterImpl
		 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getExternalCallParameter()
		 * @generated
		 */
		EClass EXTERNAL_CALL_PARAMETER = eINSTANCE.getExternalCallParameter();

		/**
		 * The meta object literal for the '<em><b>External Call</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EXTERNAL_CALL_PARAMETER__EXTERNAL_CALL = eINSTANCE.getExternalCallParameter_ExternalCall();

		/**
		 * The meta object literal for the '<em><b>Parameter</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EXTERNAL_CALL_PARAMETER__PARAMETER = eINSTANCE.getExternalCallParameter_Parameter();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.InfluencableModelVariable <em>Influencable Model Variable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.InfluencableModelVariable
		 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getInfluencableModelVariable()
		 * @generated
		 */
		EClass INFLUENCABLE_MODEL_VARIABLE = eINSTANCE.getInfluencableModelVariable();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute INFLUENCABLE_MODEL_VARIABLE__NAME = eINSTANCE.getInfluencableModelVariable_Name();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.ModelVariableCharacterizationType <em>Model Variable Characterization Type</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.ModelVariableCharacterizationType
		 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getModelVariableCharacterizationType()
		 * @generated
		 */
		EEnum MODEL_VARIABLE_CHARACTERIZATION_TYPE = eINSTANCE.getModelVariableCharacterizationType();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.RelationshipCharacterizationType <em>Relationship Characterization Type</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.RelationshipCharacterizationType
		 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getRelationshipCharacterizationType()
		 * @generated
		 */
		EEnum RELATIONSHIP_CHARACTERIZATION_TYPE = eINSTANCE.getRelationshipCharacterizationType();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.ParameterCharacterizationType <em>Parameter Characterization Type</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.ParameterCharacterizationType
		 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getParameterCharacterizationType()
		 * @generated
		 */
		EEnum PARAMETER_CHARACTERIZATION_TYPE = eINSTANCE.getParameterCharacterizationType();

	}

} //ParameterdependenciesPackage
