/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package tools.descartes.dml.mm.applicationlevel.parameterdependencies;

import org.eclipse.emf.cdo.CDOObject;
import org.eclipse.emf.common.util.EList;

import tools.descartes.dml.mm.applicationlevel.functions.EmpiricalDescription;
import tools.descartes.dml.mm.applicationlevel.functions.ExplicitDescription;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.RelationshipVariable;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Relationship</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.Relationship#getEmpiricalDescription <em>Empirical Description</em>}</li>
 *   <li>{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.Relationship#getExplicitDescription <em>Explicit Description</em>}</li>
 *   <li>{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.Relationship#getCharacterization <em>Characterization</em>}</li>
 *   <li>{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.Relationship#getDependent <em>Dependent</em>}</li>
 *   <li>{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.Relationship#getIndependent <em>Independent</em>}</li>
 * </ul>
 *
 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage#getRelationship()
 * @model abstract="true"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore constraints='EnforceExplicitDescriptionWhenExplicitCharacterizationType EnforceEmpiricalDescriptionWhenEmpiricalCharacterizationType'"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot EnforceExplicitDescriptionWhenExplicitCharacterizationType='\n\t\t\tself.characterization = RelationshipCharacterizationType::EXPLICIT implies explicitDescription &lt;&gt; null' EnforceEmpiricalDescriptionWhenEmpiricalCharacterizationType='\n\t\t\tself.characterization = RelationshipCharacterizationType::EMPIRICAL implies empiricalDescription &lt;&gt; null'"
 * @extends CDOObject
 * @generated
 */
public interface Relationship extends CDOObject {
	/**
	 * Returns the value of the '<em><b>Empirical Description</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Empirical Description</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Empirical Description</em>' containment reference.
	 * @see #setEmpiricalDescription(EmpiricalDescription)
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage#getRelationship_EmpiricalDescription()
	 * @model containment="true" resolveProxies="true"
	 * @generated
	 */
	EmpiricalDescription getEmpiricalDescription();

	/**
	 * Sets the value of the '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.Relationship#getEmpiricalDescription <em>Empirical Description</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Empirical Description</em>' containment reference.
	 * @see #getEmpiricalDescription()
	 * @generated
	 */
	void setEmpiricalDescription(EmpiricalDescription value);

	/**
	 * Returns the value of the '<em><b>Explicit Description</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Explicit Description</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Explicit Description</em>' containment reference.
	 * @see #setExplicitDescription(ExplicitDescription)
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage#getRelationship_ExplicitDescription()
	 * @model containment="true" resolveProxies="true"
	 * @generated
	 */
	ExplicitDescription getExplicitDescription();

	/**
	 * Sets the value of the '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.Relationship#getExplicitDescription <em>Explicit Description</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Explicit Description</em>' containment reference.
	 * @see #getExplicitDescription()
	 * @generated
	 */
	void setExplicitDescription(ExplicitDescription value);

	/**
	 * Returns the value of the '<em><b>Characterization</b></em>' attribute.
	 * The literals are from the enumeration {@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.RelationshipCharacterizationType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Characterization</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Characterization</em>' attribute.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.RelationshipCharacterizationType
	 * @see #setCharacterization(RelationshipCharacterizationType)
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage#getRelationship_Characterization()
	 * @model required="true"
	 * @generated
	 */
	RelationshipCharacterizationType getCharacterization();

	/**
	 * Sets the value of the '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.Relationship#getCharacterization <em>Characterization</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Characterization</em>' attribute.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.RelationshipCharacterizationType
	 * @see #getCharacterization()
	 * @generated
	 */
	void setCharacterization(RelationshipCharacterizationType value);

	/**
	 * Returns the value of the '<em><b>Dependent</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Dependent</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Dependent</em>' reference.
	 * @see #setDependent(RelationshipVariable)
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage#getRelationship_Dependent()
	 * @model required="true"
	 * @generated
	 */
	RelationshipVariable getDependent();

	/**
	 * Sets the value of the '{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.Relationship#getDependent <em>Dependent</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Dependent</em>' reference.
	 * @see #getDependent()
	 * @generated
	 */
	void setDependent(RelationshipVariable value);

	/**
	 * Returns the value of the '<em><b>Independent</b></em>' reference list.
	 * The list contents are of type {@link tools.descartes.dml.mm.applicationlevel.servicebehavior.RelationshipVariable}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Independent</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Independent</em>' reference list.
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage#getRelationship_Independent()
	 * @model required="true"
	 * @generated
	 */
	EList<RelationshipVariable> getIndependent();

} // Relationship
