/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package tools.descartes.dml.mm.applicationlevel.repository;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

import tools.descartes.dml.core.CorePackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see tools.descartes.dml.mm.applicationlevel.repository.RepositoryFactory
 * @model kind="package"
 *        annotation="http://www.eclipse.org/OCL/Import core_0='../../tools.descartes.dml.core/model/core.ecore#/' ecore_0='http://www.eclipse.org/emf/2002/Ecore' parameterdependency_0='parameterdependency.ecore#/' servicebehavior_0='servicebehavior.ecore#/'"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore invocationDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot' settingDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot' validationDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot'"
 * @generated
 */
public interface RepositoryPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "repository";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.descartes.tools/metamodel/repository/1.0";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "repository";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	RepositoryPackage eINSTANCE = tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl.init();

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.RoleImpl <em>Role</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RoleImpl
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getRole()
	 * @generated
	 */
	int ROLE = 0;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROLE__ID = CorePackage.ENTITY__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROLE__NAME = CorePackage.ENTITY__NAME;

	/**
	 * The number of structural features of the '<em>Role</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROLE_FEATURE_COUNT = CorePackage.ENTITY_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.InterfaceProvidingEntityImpl <em>Interface Providing Entity</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.InterfaceProvidingEntityImpl
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getInterfaceProvidingEntity()
	 * @generated
	 */
	int INTERFACE_PROVIDING_ENTITY = 1;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE_PROVIDING_ENTITY__ID = CorePackage.ENTITY__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE_PROVIDING_ENTITY__NAME = CorePackage.ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Interface Providing Roles</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE_PROVIDING_ENTITY__INTERFACE_PROVIDING_ROLES = CorePackage.ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Black Box Behavior</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE_PROVIDING_ENTITY__BLACK_BOX_BEHAVIOR = CorePackage.ENTITY_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Interface Providing Entity</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE_PROVIDING_ENTITY_FEATURE_COUNT = CorePackage.ENTITY_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.InterfaceRequiringEntityImpl <em>Interface Requiring Entity</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.InterfaceRequiringEntityImpl
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getInterfaceRequiringEntity()
	 * @generated
	 */
	int INTERFACE_REQUIRING_ENTITY = 2;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE_REQUIRING_ENTITY__ID = CorePackage.ENTITY__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE_REQUIRING_ENTITY__NAME = CorePackage.ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Interface Requiring Roles</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE_REQUIRING_ENTITY__INTERFACE_REQUIRING_ROLES = CorePackage.ENTITY_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Interface Requiring Entity</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE_REQUIRING_ENTITY_FEATURE_COUNT = CorePackage.ENTITY_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.InterfaceProvidingRequiringEntityImpl <em>Interface Providing Requiring Entity</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.InterfaceProvidingRequiringEntityImpl
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getInterfaceProvidingRequiringEntity()
	 * @generated
	 */
	int INTERFACE_PROVIDING_REQUIRING_ENTITY = 3;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE_PROVIDING_REQUIRING_ENTITY__ID = INTERFACE_PROVIDING_ENTITY__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE_PROVIDING_REQUIRING_ENTITY__NAME = INTERFACE_PROVIDING_ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Interface Providing Roles</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE_PROVIDING_REQUIRING_ENTITY__INTERFACE_PROVIDING_ROLES = INTERFACE_PROVIDING_ENTITY__INTERFACE_PROVIDING_ROLES;

	/**
	 * The feature id for the '<em><b>Black Box Behavior</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE_PROVIDING_REQUIRING_ENTITY__BLACK_BOX_BEHAVIOR = INTERFACE_PROVIDING_ENTITY__BLACK_BOX_BEHAVIOR;

	/**
	 * The feature id for the '<em><b>Interface Requiring Roles</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE_PROVIDING_REQUIRING_ENTITY__INTERFACE_REQUIRING_ROLES = INTERFACE_PROVIDING_ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Coarse Grained Behavior</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE_PROVIDING_REQUIRING_ENTITY__COARSE_GRAINED_BEHAVIOR = INTERFACE_PROVIDING_ENTITY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Relationships</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE_PROVIDING_REQUIRING_ENTITY__RELATIONSHIPS = INTERFACE_PROVIDING_ENTITY_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Interface Providing Requiring Entity</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE_PROVIDING_REQUIRING_ENTITY_FEATURE_COUNT = INTERFACE_PROVIDING_ENTITY_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.ImportImpl <em>Import</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.ImportImpl
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getImport()
	 * @generated
	 */
	int IMPORT = 4;

	/**
	 * The feature id for the '<em><b>Import URI</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IMPORT__IMPORT_URI = 0;

	/**
	 * The feature id for the '<em><b>Repository</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IMPORT__REPOSITORY = 1;

	/**
	 * The number of structural features of the '<em>Import</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IMPORT_FEATURE_COUNT = 2;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.InterfaceRequiringRoleImpl <em>Interface Requiring Role</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.InterfaceRequiringRoleImpl
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getInterfaceRequiringRole()
	 * @generated
	 */
	int INTERFACE_REQUIRING_ROLE = 5;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE_REQUIRING_ROLE__ID = ROLE__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE_REQUIRING_ROLE__NAME = ROLE__NAME;

	/**
	 * The feature id for the '<em><b>Interface Requiring Entity</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE_REQUIRING_ROLE__INTERFACE_REQUIRING_ENTITY = ROLE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Interface</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE_REQUIRING_ROLE__INTERFACE = ROLE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Interface Requiring Role</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE_REQUIRING_ROLE_FEATURE_COUNT = ROLE_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.InterfaceProvidingRoleImpl <em>Interface Providing Role</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.InterfaceProvidingRoleImpl
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getInterfaceProvidingRole()
	 * @generated
	 */
	int INTERFACE_PROVIDING_ROLE = 6;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE_PROVIDING_ROLE__ID = ROLE__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE_PROVIDING_ROLE__NAME = ROLE__NAME;

	/**
	 * The feature id for the '<em><b>Interface Providing Entity</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE_PROVIDING_ROLE__INTERFACE_PROVIDING_ENTITY = ROLE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Interface</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE_PROVIDING_ROLE__INTERFACE = ROLE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Interface Providing Role</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE_PROVIDING_ROLE_FEATURE_COUNT = ROLE_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.ComposedStructureImpl <em>Composed Structure</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.ComposedStructureImpl
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getComposedStructure()
	 * @generated
	 */
	int COMPOSED_STRUCTURE = 7;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSED_STRUCTURE__ID = CorePackage.ENTITY__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSED_STRUCTURE__NAME = CorePackage.ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Assembly Contexts</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSED_STRUCTURE__ASSEMBLY_CONTEXTS = CorePackage.ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Assembly Connectors</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSED_STRUCTURE__ASSEMBLY_CONNECTORS = CorePackage.ENTITY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Providing Delegation Connectors</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSED_STRUCTURE__PROVIDING_DELEGATION_CONNECTORS = CorePackage.ENTITY_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Requiring Delegation Connectors</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSED_STRUCTURE__REQUIRING_DELEGATION_CONNECTORS = CorePackage.ENTITY_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Composed Structure</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSED_STRUCTURE_FEATURE_COUNT = CorePackage.ENTITY_FEATURE_COUNT + 4;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.ComposedProvidingRequiringEntityImpl <em>Composed Providing Requiring Entity</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.ComposedProvidingRequiringEntityImpl
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getComposedProvidingRequiringEntity()
	 * @generated
	 */
	int COMPOSED_PROVIDING_REQUIRING_ENTITY = 8;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSED_PROVIDING_REQUIRING_ENTITY__ID = COMPOSED_STRUCTURE__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSED_PROVIDING_REQUIRING_ENTITY__NAME = COMPOSED_STRUCTURE__NAME;

	/**
	 * The feature id for the '<em><b>Assembly Contexts</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSED_PROVIDING_REQUIRING_ENTITY__ASSEMBLY_CONTEXTS = COMPOSED_STRUCTURE__ASSEMBLY_CONTEXTS;

	/**
	 * The feature id for the '<em><b>Assembly Connectors</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSED_PROVIDING_REQUIRING_ENTITY__ASSEMBLY_CONNECTORS = COMPOSED_STRUCTURE__ASSEMBLY_CONNECTORS;

	/**
	 * The feature id for the '<em><b>Providing Delegation Connectors</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSED_PROVIDING_REQUIRING_ENTITY__PROVIDING_DELEGATION_CONNECTORS = COMPOSED_STRUCTURE__PROVIDING_DELEGATION_CONNECTORS;

	/**
	 * The feature id for the '<em><b>Requiring Delegation Connectors</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSED_PROVIDING_REQUIRING_ENTITY__REQUIRING_DELEGATION_CONNECTORS = COMPOSED_STRUCTURE__REQUIRING_DELEGATION_CONNECTORS;

	/**
	 * The feature id for the '<em><b>Interface Providing Roles</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSED_PROVIDING_REQUIRING_ENTITY__INTERFACE_PROVIDING_ROLES = COMPOSED_STRUCTURE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Black Box Behavior</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSED_PROVIDING_REQUIRING_ENTITY__BLACK_BOX_BEHAVIOR = COMPOSED_STRUCTURE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Interface Requiring Roles</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSED_PROVIDING_REQUIRING_ENTITY__INTERFACE_REQUIRING_ROLES = COMPOSED_STRUCTURE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Coarse Grained Behavior</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSED_PROVIDING_REQUIRING_ENTITY__COARSE_GRAINED_BEHAVIOR = COMPOSED_STRUCTURE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Relationships</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSED_PROVIDING_REQUIRING_ENTITY__RELATIONSHIPS = COMPOSED_STRUCTURE_FEATURE_COUNT + 4;

	/**
	 * The number of structural features of the '<em>Composed Providing Requiring Entity</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSED_PROVIDING_REQUIRING_ENTITY_FEATURE_COUNT = COMPOSED_STRUCTURE_FEATURE_COUNT + 5;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.InterfaceImpl <em>Interface</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.InterfaceImpl
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getInterface()
	 * @generated
	 */
	int INTERFACE = 9;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE__ID = CorePackage.ENTITY__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE__NAME = CorePackage.ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Repository</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE__REPOSITORY = CorePackage.ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Parent Interfaces</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE__PARENT_INTERFACES = CorePackage.ENTITY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Signatures</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE__SIGNATURES = CorePackage.ENTITY_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Interface</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE_FEATURE_COUNT = CorePackage.ENTITY_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.SignatureImpl <em>Signature</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.SignatureImpl
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getSignature()
	 * @generated
	 */
	int SIGNATURE = 10;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIGNATURE__ID = CorePackage.ENTITY__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIGNATURE__NAME = CorePackage.ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIGNATURE__PARAMETERS = CorePackage.ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Return Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIGNATURE__RETURN_TYPE = CorePackage.ENTITY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Interface</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIGNATURE__INTERFACE = CorePackage.ENTITY_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Signature</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIGNATURE_FEATURE_COUNT = CorePackage.ENTITY_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.ParameterImpl <em>Parameter</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.ParameterImpl
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getParameter()
	 * @generated
	 */
	int PARAMETER = 11;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER__NAME = CorePackage.NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Data Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER__DATA_TYPE = CorePackage.NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Parameter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER_FEATURE_COUNT = CorePackage.NAMED_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryImpl <em>Repository</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryImpl
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getRepository()
	 * @generated
	 */
	int REPOSITORY = 12;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPOSITORY__ID = CorePackage.ENTITY__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPOSITORY__NAME = CorePackage.ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Imports</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPOSITORY__IMPORTS = CorePackage.ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Datatypes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPOSITORY__DATATYPES = CorePackage.ENTITY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Interfaces</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPOSITORY__INTERFACES = CorePackage.ENTITY_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Components</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPOSITORY__COMPONENTS = CorePackage.ENTITY_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Repository</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPOSITORY_FEATURE_COUNT = CorePackage.ENTITY_FEATURE_COUNT + 4;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryComponentImpl <em>Component</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryComponentImpl
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getRepositoryComponent()
	 * @generated
	 */
	int REPOSITORY_COMPONENT = 13;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPOSITORY_COMPONENT__ID = INTERFACE_PROVIDING_REQUIRING_ENTITY__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPOSITORY_COMPONENT__NAME = INTERFACE_PROVIDING_REQUIRING_ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Interface Providing Roles</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPOSITORY_COMPONENT__INTERFACE_PROVIDING_ROLES = INTERFACE_PROVIDING_REQUIRING_ENTITY__INTERFACE_PROVIDING_ROLES;

	/**
	 * The feature id for the '<em><b>Black Box Behavior</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPOSITORY_COMPONENT__BLACK_BOX_BEHAVIOR = INTERFACE_PROVIDING_REQUIRING_ENTITY__BLACK_BOX_BEHAVIOR;

	/**
	 * The feature id for the '<em><b>Interface Requiring Roles</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPOSITORY_COMPONENT__INTERFACE_REQUIRING_ROLES = INTERFACE_PROVIDING_REQUIRING_ENTITY__INTERFACE_REQUIRING_ROLES;

	/**
	 * The feature id for the '<em><b>Coarse Grained Behavior</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPOSITORY_COMPONENT__COARSE_GRAINED_BEHAVIOR = INTERFACE_PROVIDING_REQUIRING_ENTITY__COARSE_GRAINED_BEHAVIOR;

	/**
	 * The feature id for the '<em><b>Relationships</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPOSITORY_COMPONENT__RELATIONSHIPS = INTERFACE_PROVIDING_REQUIRING_ENTITY__RELATIONSHIPS;

	/**
	 * The feature id for the '<em><b>Repository</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPOSITORY_COMPONENT__REPOSITORY = INTERFACE_PROVIDING_REQUIRING_ENTITY_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Component</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPOSITORY_COMPONENT_FEATURE_COUNT = INTERFACE_PROVIDING_REQUIRING_ENTITY_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.BasicComponentImpl <em>Basic Component</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.BasicComponentImpl
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getBasicComponent()
	 * @generated
	 */
	int BASIC_COMPONENT = 14;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIC_COMPONENT__ID = REPOSITORY_COMPONENT__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIC_COMPONENT__NAME = REPOSITORY_COMPONENT__NAME;

	/**
	 * The feature id for the '<em><b>Interface Providing Roles</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIC_COMPONENT__INTERFACE_PROVIDING_ROLES = REPOSITORY_COMPONENT__INTERFACE_PROVIDING_ROLES;

	/**
	 * The feature id for the '<em><b>Black Box Behavior</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIC_COMPONENT__BLACK_BOX_BEHAVIOR = REPOSITORY_COMPONENT__BLACK_BOX_BEHAVIOR;

	/**
	 * The feature id for the '<em><b>Interface Requiring Roles</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIC_COMPONENT__INTERFACE_REQUIRING_ROLES = REPOSITORY_COMPONENT__INTERFACE_REQUIRING_ROLES;

	/**
	 * The feature id for the '<em><b>Coarse Grained Behavior</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIC_COMPONENT__COARSE_GRAINED_BEHAVIOR = REPOSITORY_COMPONENT__COARSE_GRAINED_BEHAVIOR;

	/**
	 * The feature id for the '<em><b>Relationships</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIC_COMPONENT__RELATIONSHIPS = REPOSITORY_COMPONENT__RELATIONSHIPS;

	/**
	 * The feature id for the '<em><b>Repository</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIC_COMPONENT__REPOSITORY = REPOSITORY_COMPONENT__REPOSITORY;

	/**
	 * The feature id for the '<em><b>Semaphores</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIC_COMPONENT__SEMAPHORES = REPOSITORY_COMPONENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Fine Grained Behavior</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIC_COMPONENT__FINE_GRAINED_BEHAVIOR = REPOSITORY_COMPONENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Basic Component</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIC_COMPONENT_FEATURE_COUNT = REPOSITORY_COMPONENT_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.SemaphoreImpl <em>Semaphore</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.SemaphoreImpl
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getSemaphore()
	 * @generated
	 */
	int SEMAPHORE = 15;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEMAPHORE__ID = CorePackage.ADAPTABLE_ENTITY__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEMAPHORE__NAME = CorePackage.ADAPTABLE_ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Capacity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEMAPHORE__CAPACITY = CorePackage.ADAPTABLE_ENTITY_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Semaphore</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEMAPHORE_FEATURE_COUNT = CorePackage.ADAPTABLE_ENTITY_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.CompositeComponentImpl <em>Composite Component</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.CompositeComponentImpl
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getCompositeComponent()
	 * @generated
	 */
	int COMPOSITE_COMPONENT = 16;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_COMPONENT__ID = REPOSITORY_COMPONENT__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_COMPONENT__NAME = REPOSITORY_COMPONENT__NAME;

	/**
	 * The feature id for the '<em><b>Interface Providing Roles</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_COMPONENT__INTERFACE_PROVIDING_ROLES = REPOSITORY_COMPONENT__INTERFACE_PROVIDING_ROLES;

	/**
	 * The feature id for the '<em><b>Black Box Behavior</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_COMPONENT__BLACK_BOX_BEHAVIOR = REPOSITORY_COMPONENT__BLACK_BOX_BEHAVIOR;

	/**
	 * The feature id for the '<em><b>Interface Requiring Roles</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_COMPONENT__INTERFACE_REQUIRING_ROLES = REPOSITORY_COMPONENT__INTERFACE_REQUIRING_ROLES;

	/**
	 * The feature id for the '<em><b>Coarse Grained Behavior</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_COMPONENT__COARSE_GRAINED_BEHAVIOR = REPOSITORY_COMPONENT__COARSE_GRAINED_BEHAVIOR;

	/**
	 * The feature id for the '<em><b>Relationships</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_COMPONENT__RELATIONSHIPS = REPOSITORY_COMPONENT__RELATIONSHIPS;

	/**
	 * The feature id for the '<em><b>Repository</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_COMPONENT__REPOSITORY = REPOSITORY_COMPONENT__REPOSITORY;

	/**
	 * The feature id for the '<em><b>Assembly Contexts</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_COMPONENT__ASSEMBLY_CONTEXTS = REPOSITORY_COMPONENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Assembly Connectors</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_COMPONENT__ASSEMBLY_CONNECTORS = REPOSITORY_COMPONENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Providing Delegation Connectors</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_COMPONENT__PROVIDING_DELEGATION_CONNECTORS = REPOSITORY_COMPONENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Requiring Delegation Connectors</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_COMPONENT__REQUIRING_DELEGATION_CONNECTORS = REPOSITORY_COMPONENT_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Composite Component</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_COMPONENT_FEATURE_COUNT = REPOSITORY_COMPONENT_FEATURE_COUNT + 4;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.SubSystemImpl <em>Sub System</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.SubSystemImpl
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getSubSystem()
	 * @generated
	 */
	int SUB_SYSTEM = 17;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_SYSTEM__ID = REPOSITORY_COMPONENT__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_SYSTEM__NAME = REPOSITORY_COMPONENT__NAME;

	/**
	 * The feature id for the '<em><b>Interface Providing Roles</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_SYSTEM__INTERFACE_PROVIDING_ROLES = REPOSITORY_COMPONENT__INTERFACE_PROVIDING_ROLES;

	/**
	 * The feature id for the '<em><b>Black Box Behavior</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_SYSTEM__BLACK_BOX_BEHAVIOR = REPOSITORY_COMPONENT__BLACK_BOX_BEHAVIOR;

	/**
	 * The feature id for the '<em><b>Interface Requiring Roles</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_SYSTEM__INTERFACE_REQUIRING_ROLES = REPOSITORY_COMPONENT__INTERFACE_REQUIRING_ROLES;

	/**
	 * The feature id for the '<em><b>Coarse Grained Behavior</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_SYSTEM__COARSE_GRAINED_BEHAVIOR = REPOSITORY_COMPONENT__COARSE_GRAINED_BEHAVIOR;

	/**
	 * The feature id for the '<em><b>Relationships</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_SYSTEM__RELATIONSHIPS = REPOSITORY_COMPONENT__RELATIONSHIPS;

	/**
	 * The feature id for the '<em><b>Repository</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_SYSTEM__REPOSITORY = REPOSITORY_COMPONENT__REPOSITORY;

	/**
	 * The feature id for the '<em><b>Assembly Contexts</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_SYSTEM__ASSEMBLY_CONTEXTS = REPOSITORY_COMPONENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Assembly Connectors</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_SYSTEM__ASSEMBLY_CONNECTORS = REPOSITORY_COMPONENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Providing Delegation Connectors</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_SYSTEM__PROVIDING_DELEGATION_CONNECTORS = REPOSITORY_COMPONENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Requiring Delegation Connectors</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_SYSTEM__REQUIRING_DELEGATION_CONNECTORS = REPOSITORY_COMPONENT_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Sub System</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_SYSTEM_FEATURE_COUNT = REPOSITORY_COMPONENT_FEATURE_COUNT + 4;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.DataTypeImpl <em>Data Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.DataTypeImpl
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getDataType()
	 * @generated
	 */
	int DATA_TYPE = 18;

	/**
	 * The feature id for the '<em><b>Repository</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE__REPOSITORY = 0;

	/**
	 * The number of structural features of the '<em>Data Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.CollectionDataTypeImpl <em>Collection Data Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.CollectionDataTypeImpl
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getCollectionDataType()
	 * @generated
	 */
	int COLLECTION_DATA_TYPE = 19;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COLLECTION_DATA_TYPE__ID = CorePackage.ENTITY__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COLLECTION_DATA_TYPE__NAME = CorePackage.ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Repository</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COLLECTION_DATA_TYPE__REPOSITORY = CorePackage.ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Inner Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COLLECTION_DATA_TYPE__INNER_TYPE = CorePackage.ENTITY_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Collection Data Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COLLECTION_DATA_TYPE_FEATURE_COUNT = CorePackage.ENTITY_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.CompositeDataTypeImpl <em>Composite Data Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.CompositeDataTypeImpl
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getCompositeDataType()
	 * @generated
	 */
	int COMPOSITE_DATA_TYPE = 20;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_DATA_TYPE__ID = CorePackage.ENTITY__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_DATA_TYPE__NAME = CorePackage.ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Repository</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_DATA_TYPE__REPOSITORY = CorePackage.ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Inner Declarations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_DATA_TYPE__INNER_DECLARATIONS = CorePackage.ENTITY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Parent Types</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_DATA_TYPE__PARENT_TYPES = CorePackage.ENTITY_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Composite Data Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_DATA_TYPE_FEATURE_COUNT = CorePackage.ENTITY_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.InnerDeclarationImpl <em>Inner Declaration</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.InnerDeclarationImpl
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getInnerDeclaration()
	 * @generated
	 */
	int INNER_DECLARATION = 21;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INNER_DECLARATION__ID = CorePackage.ENTITY__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INNER_DECLARATION__NAME = CorePackage.ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Data Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INNER_DECLARATION__DATA_TYPE = CorePackage.ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Composite Data Type</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INNER_DECLARATION__COMPOSITE_DATA_TYPE = CorePackage.ENTITY_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Inner Declaration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INNER_DECLARATION_FEATURE_COUNT = CorePackage.ENTITY_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.PrimitiveDataTypeImpl <em>Primitive Data Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.PrimitiveDataTypeImpl
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getPrimitiveDataType()
	 * @generated
	 */
	int PRIMITIVE_DATA_TYPE = 22;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_DATA_TYPE__ID = CorePackage.ENTITY__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_DATA_TYPE__NAME = CorePackage.ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Repository</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_DATA_TYPE__REPOSITORY = CorePackage.ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_DATA_TYPE__TYPE = CorePackage.ENTITY_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Primitive Data Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_DATA_TYPE_FEATURE_COUNT = CorePackage.ENTITY_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.AssemblyContextImpl <em>Assembly Context</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.AssemblyContextImpl
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getAssemblyContext()
	 * @generated
	 */
	int ASSEMBLY_CONTEXT = 23;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSEMBLY_CONTEXT__ID = CorePackage.ENTITY__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSEMBLY_CONTEXT__NAME = CorePackage.ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Parent Structure</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSEMBLY_CONTEXT__PARENT_STRUCTURE = CorePackage.ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Encapsulated Component</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSEMBLY_CONTEXT__ENCAPSULATED_COMPONENT = CorePackage.ENTITY_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Assembly Context</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSEMBLY_CONTEXT_FEATURE_COUNT = CorePackage.ENTITY_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.AssemblyConnectorImpl <em>Assembly Connector</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.AssemblyConnectorImpl
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getAssemblyConnector()
	 * @generated
	 */
	int ASSEMBLY_CONNECTOR = 24;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSEMBLY_CONNECTOR__ID = CorePackage.CONNECTOR__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSEMBLY_CONNECTOR__NAME = CorePackage.CONNECTOR__NAME;

	/**
	 * The feature id for the '<em><b>Parent Structure</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSEMBLY_CONNECTOR__PARENT_STRUCTURE = CorePackage.CONNECTOR_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Interface Requiring Role</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSEMBLY_CONNECTOR__INTERFACE_REQUIRING_ROLE = CorePackage.CONNECTOR_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Interface Providing Role</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSEMBLY_CONNECTOR__INTERFACE_PROVIDING_ROLE = CorePackage.CONNECTOR_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Providing Assembly Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSEMBLY_CONNECTOR__PROVIDING_ASSEMBLY_CONTEXT = CorePackage.CONNECTOR_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Requiring Assembly Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSEMBLY_CONNECTOR__REQUIRING_ASSEMBLY_CONTEXT = CorePackage.CONNECTOR_FEATURE_COUNT + 4;

	/**
	 * The number of structural features of the '<em>Assembly Connector</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSEMBLY_CONNECTOR_FEATURE_COUNT = CorePackage.CONNECTOR_FEATURE_COUNT + 5;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.DelegationConnectorImpl <em>Delegation Connector</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.DelegationConnectorImpl
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getDelegationConnector()
	 * @generated
	 */
	int DELEGATION_CONNECTOR = 25;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DELEGATION_CONNECTOR__ID = CorePackage.CONNECTOR__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DELEGATION_CONNECTOR__NAME = CorePackage.CONNECTOR__NAME;

	/**
	 * The feature id for the '<em><b>Assembly Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DELEGATION_CONNECTOR__ASSEMBLY_CONTEXT = CorePackage.CONNECTOR_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Delegation Connector</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DELEGATION_CONNECTOR_FEATURE_COUNT = CorePackage.CONNECTOR_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.ProvidingDelegationConnectorImpl <em>Providing Delegation Connector</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.ProvidingDelegationConnectorImpl
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getProvidingDelegationConnector()
	 * @generated
	 */
	int PROVIDING_DELEGATION_CONNECTOR = 26;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROVIDING_DELEGATION_CONNECTOR__ID = DELEGATION_CONNECTOR__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROVIDING_DELEGATION_CONNECTOR__NAME = DELEGATION_CONNECTOR__NAME;

	/**
	 * The feature id for the '<em><b>Assembly Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROVIDING_DELEGATION_CONNECTOR__ASSEMBLY_CONTEXT = DELEGATION_CONNECTOR__ASSEMBLY_CONTEXT;

	/**
	 * The feature id for the '<em><b>Parent Structure</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROVIDING_DELEGATION_CONNECTOR__PARENT_STRUCTURE = DELEGATION_CONNECTOR_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Inner Interface Providing Role</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROVIDING_DELEGATION_CONNECTOR__INNER_INTERFACE_PROVIDING_ROLE = DELEGATION_CONNECTOR_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Outer Interface Providing Role</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROVIDING_DELEGATION_CONNECTOR__OUTER_INTERFACE_PROVIDING_ROLE = DELEGATION_CONNECTOR_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Providing Delegation Connector</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROVIDING_DELEGATION_CONNECTOR_FEATURE_COUNT = DELEGATION_CONNECTOR_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.RequiringDelegationConnectorImpl <em>Requiring Delegation Connector</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RequiringDelegationConnectorImpl
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getRequiringDelegationConnector()
	 * @generated
	 */
	int REQUIRING_DELEGATION_CONNECTOR = 27;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REQUIRING_DELEGATION_CONNECTOR__ID = DELEGATION_CONNECTOR__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REQUIRING_DELEGATION_CONNECTOR__NAME = DELEGATION_CONNECTOR__NAME;

	/**
	 * The feature id for the '<em><b>Assembly Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REQUIRING_DELEGATION_CONNECTOR__ASSEMBLY_CONTEXT = DELEGATION_CONNECTOR__ASSEMBLY_CONTEXT;

	/**
	 * The feature id for the '<em><b>Parent Structure</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REQUIRING_DELEGATION_CONNECTOR__PARENT_STRUCTURE = DELEGATION_CONNECTOR_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Inner Interface Requiring Role</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REQUIRING_DELEGATION_CONNECTOR__INNER_INTERFACE_REQUIRING_ROLE = DELEGATION_CONNECTOR_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Outer Interface Requiring Role</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REQUIRING_DELEGATION_CONNECTOR__OUTER_INTERFACE_REQUIRING_ROLE = DELEGATION_CONNECTOR_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Requiring Delegation Connector</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REQUIRING_DELEGATION_CONNECTOR_FEATURE_COUNT = DELEGATION_CONNECTOR_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.InputParameterImpl <em>Input Parameter</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.InputParameterImpl
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getInputParameter()
	 * @generated
	 */
	int INPUT_PARAMETER = 28;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUT_PARAMETER__NAME = PARAMETER__NAME;

	/**
	 * The feature id for the '<em><b>Data Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUT_PARAMETER__DATA_TYPE = PARAMETER__DATA_TYPE;

	/**
	 * The number of structural features of the '<em>Input Parameter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUT_PARAMETER_FEATURE_COUNT = PARAMETER_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.OutputParameterImpl <em>Output Parameter</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.OutputParameterImpl
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getOutputParameter()
	 * @generated
	 */
	int OUTPUT_PARAMETER = 29;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OUTPUT_PARAMETER__NAME = PARAMETER__NAME;

	/**
	 * The feature id for the '<em><b>Data Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OUTPUT_PARAMETER__DATA_TYPE = PARAMETER__DATA_TYPE;

	/**
	 * The number of structural features of the '<em>Output Parameter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OUTPUT_PARAMETER_FEATURE_COUNT = PARAMETER_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.InputOutputParameterImpl <em>Input Output Parameter</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.InputOutputParameterImpl
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getInputOutputParameter()
	 * @generated
	 */
	int INPUT_OUTPUT_PARAMETER = 30;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUT_OUTPUT_PARAMETER__NAME = INPUT_PARAMETER__NAME;

	/**
	 * The feature id for the '<em><b>Data Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUT_OUTPUT_PARAMETER__DATA_TYPE = INPUT_PARAMETER__DATA_TYPE;

	/**
	 * The number of structural features of the '<em>Input Output Parameter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUT_OUTPUT_PARAMETER_FEATURE_COUNT = INPUT_PARAMETER_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.ServiceImpl <em>Service</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.ServiceImpl
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getService()
	 * @generated
	 */
	int SERVICE = 31;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE__ID = ASSEMBLY_CONTEXT__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE__NAME = ASSEMBLY_CONTEXT__NAME;

	/**
	 * The feature id for the '<em><b>Parent Structure</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE__PARENT_STRUCTURE = ASSEMBLY_CONTEXT__PARENT_STRUCTURE;

	/**
	 * The feature id for the '<em><b>Encapsulated Component</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE__ENCAPSULATED_COMPONENT = ASSEMBLY_CONTEXT__ENCAPSULATED_COMPONENT;

	/**
	 * The feature id for the '<em><b>Amount</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE__AMOUNT = ASSEMBLY_CONTEXT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Service</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FEATURE_COUNT = ASSEMBLY_CONTEXT_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.repository.ParameterModifier <em>Parameter Modifier</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.repository.ParameterModifier
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getParameterModifier()
	 * @generated
	 */
	int PARAMETER_MODIFIER = 32;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.repository.PrimitiveTypeEnum <em>Primitive Type Enum</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.repository.PrimitiveTypeEnum
	 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getPrimitiveTypeEnum()
	 * @generated
	 */
	int PRIMITIVE_TYPE_ENUM = 33;


	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.repository.Role <em>Role</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Role</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.Role
	 * @generated
	 */
	EClass getRole();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.repository.InterfaceProvidingEntity <em>Interface Providing Entity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Interface Providing Entity</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.InterfaceProvidingEntity
	 * @generated
	 */
	EClass getInterfaceProvidingEntity();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dml.mm.applicationlevel.repository.InterfaceProvidingEntity#getInterfaceProvidingRoles <em>Interface Providing Roles</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Interface Providing Roles</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.InterfaceProvidingEntity#getInterfaceProvidingRoles()
	 * @see #getInterfaceProvidingEntity()
	 * @generated
	 */
	EReference getInterfaceProvidingEntity_InterfaceProvidingRoles();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dml.mm.applicationlevel.repository.InterfaceProvidingEntity#getBlackBoxBehavior <em>Black Box Behavior</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Black Box Behavior</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.InterfaceProvidingEntity#getBlackBoxBehavior()
	 * @see #getInterfaceProvidingEntity()
	 * @generated
	 */
	EReference getInterfaceProvidingEntity_BlackBoxBehavior();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.repository.InterfaceRequiringEntity <em>Interface Requiring Entity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Interface Requiring Entity</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.InterfaceRequiringEntity
	 * @generated
	 */
	EClass getInterfaceRequiringEntity();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dml.mm.applicationlevel.repository.InterfaceRequiringEntity#getInterfaceRequiringRoles <em>Interface Requiring Roles</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Interface Requiring Roles</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.InterfaceRequiringEntity#getInterfaceRequiringRoles()
	 * @see #getInterfaceRequiringEntity()
	 * @generated
	 */
	EReference getInterfaceRequiringEntity_InterfaceRequiringRoles();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.repository.InterfaceProvidingRequiringEntity <em>Interface Providing Requiring Entity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Interface Providing Requiring Entity</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.InterfaceProvidingRequiringEntity
	 * @generated
	 */
	EClass getInterfaceProvidingRequiringEntity();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dml.mm.applicationlevel.repository.InterfaceProvidingRequiringEntity#getCoarseGrainedBehavior <em>Coarse Grained Behavior</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Coarse Grained Behavior</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.InterfaceProvidingRequiringEntity#getCoarseGrainedBehavior()
	 * @see #getInterfaceProvidingRequiringEntity()
	 * @generated
	 */
	EReference getInterfaceProvidingRequiringEntity_CoarseGrainedBehavior();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dml.mm.applicationlevel.repository.InterfaceProvidingRequiringEntity#getRelationships <em>Relationships</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Relationships</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.InterfaceProvidingRequiringEntity#getRelationships()
	 * @see #getInterfaceProvidingRequiringEntity()
	 * @generated
	 */
	EReference getInterfaceProvidingRequiringEntity_Relationships();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.repository.Import <em>Import</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Import</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.Import
	 * @generated
	 */
	EClass getImport();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dml.mm.applicationlevel.repository.Import#getImportURI <em>Import URI</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Import URI</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.Import#getImportURI()
	 * @see #getImport()
	 * @generated
	 */
	EAttribute getImport_ImportURI();

	/**
	 * Returns the meta object for the container reference '{@link tools.descartes.dml.mm.applicationlevel.repository.Import#getRepository <em>Repository</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Repository</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.Import#getRepository()
	 * @see #getImport()
	 * @generated
	 */
	EReference getImport_Repository();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.repository.InterfaceRequiringRole <em>Interface Requiring Role</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Interface Requiring Role</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.InterfaceRequiringRole
	 * @generated
	 */
	EClass getInterfaceRequiringRole();

	/**
	 * Returns the meta object for the container reference '{@link tools.descartes.dml.mm.applicationlevel.repository.InterfaceRequiringRole#getInterfaceRequiringEntity <em>Interface Requiring Entity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Interface Requiring Entity</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.InterfaceRequiringRole#getInterfaceRequiringEntity()
	 * @see #getInterfaceRequiringRole()
	 * @generated
	 */
	EReference getInterfaceRequiringRole_InterfaceRequiringEntity();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dml.mm.applicationlevel.repository.InterfaceRequiringRole#getInterface <em>Interface</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Interface</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.InterfaceRequiringRole#getInterface()
	 * @see #getInterfaceRequiringRole()
	 * @generated
	 */
	EReference getInterfaceRequiringRole_Interface();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.repository.InterfaceProvidingRole <em>Interface Providing Role</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Interface Providing Role</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.InterfaceProvidingRole
	 * @generated
	 */
	EClass getInterfaceProvidingRole();

	/**
	 * Returns the meta object for the container reference '{@link tools.descartes.dml.mm.applicationlevel.repository.InterfaceProvidingRole#getInterfaceProvidingEntity <em>Interface Providing Entity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Interface Providing Entity</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.InterfaceProvidingRole#getInterfaceProvidingEntity()
	 * @see #getInterfaceProvidingRole()
	 * @generated
	 */
	EReference getInterfaceProvidingRole_InterfaceProvidingEntity();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dml.mm.applicationlevel.repository.InterfaceProvidingRole#getInterface <em>Interface</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Interface</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.InterfaceProvidingRole#getInterface()
	 * @see #getInterfaceProvidingRole()
	 * @generated
	 */
	EReference getInterfaceProvidingRole_Interface();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.repository.ComposedStructure <em>Composed Structure</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Composed Structure</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.ComposedStructure
	 * @generated
	 */
	EClass getComposedStructure();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dml.mm.applicationlevel.repository.ComposedStructure#getAssemblyContexts <em>Assembly Contexts</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Assembly Contexts</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.ComposedStructure#getAssemblyContexts()
	 * @see #getComposedStructure()
	 * @generated
	 */
	EReference getComposedStructure_AssemblyContexts();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dml.mm.applicationlevel.repository.ComposedStructure#getAssemblyConnectors <em>Assembly Connectors</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Assembly Connectors</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.ComposedStructure#getAssemblyConnectors()
	 * @see #getComposedStructure()
	 * @generated
	 */
	EReference getComposedStructure_AssemblyConnectors();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dml.mm.applicationlevel.repository.ComposedStructure#getProvidingDelegationConnectors <em>Providing Delegation Connectors</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Providing Delegation Connectors</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.ComposedStructure#getProvidingDelegationConnectors()
	 * @see #getComposedStructure()
	 * @generated
	 */
	EReference getComposedStructure_ProvidingDelegationConnectors();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dml.mm.applicationlevel.repository.ComposedStructure#getRequiringDelegationConnectors <em>Requiring Delegation Connectors</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Requiring Delegation Connectors</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.ComposedStructure#getRequiringDelegationConnectors()
	 * @see #getComposedStructure()
	 * @generated
	 */
	EReference getComposedStructure_RequiringDelegationConnectors();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.repository.ComposedProvidingRequiringEntity <em>Composed Providing Requiring Entity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Composed Providing Requiring Entity</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.ComposedProvidingRequiringEntity
	 * @generated
	 */
	EClass getComposedProvidingRequiringEntity();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.repository.Interface <em>Interface</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Interface</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.Interface
	 * @generated
	 */
	EClass getInterface();

	/**
	 * Returns the meta object for the container reference '{@link tools.descartes.dml.mm.applicationlevel.repository.Interface#getRepository <em>Repository</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Repository</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.Interface#getRepository()
	 * @see #getInterface()
	 * @generated
	 */
	EReference getInterface_Repository();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dml.mm.applicationlevel.repository.Interface#getParentInterfaces <em>Parent Interfaces</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Parent Interfaces</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.Interface#getParentInterfaces()
	 * @see #getInterface()
	 * @generated
	 */
	EReference getInterface_ParentInterfaces();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dml.mm.applicationlevel.repository.Interface#getSignatures <em>Signatures</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Signatures</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.Interface#getSignatures()
	 * @see #getInterface()
	 * @generated
	 */
	EReference getInterface_Signatures();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.repository.Signature <em>Signature</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Signature</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.Signature
	 * @generated
	 */
	EClass getSignature();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dml.mm.applicationlevel.repository.Signature#getParameters <em>Parameters</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Parameters</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.Signature#getParameters()
	 * @see #getSignature()
	 * @generated
	 */
	EReference getSignature_Parameters();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dml.mm.applicationlevel.repository.Signature#getReturnType <em>Return Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Return Type</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.Signature#getReturnType()
	 * @see #getSignature()
	 * @generated
	 */
	EReference getSignature_ReturnType();

	/**
	 * Returns the meta object for the container reference '{@link tools.descartes.dml.mm.applicationlevel.repository.Signature#getInterface <em>Interface</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Interface</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.Signature#getInterface()
	 * @see #getSignature()
	 * @generated
	 */
	EReference getSignature_Interface();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.repository.Parameter <em>Parameter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Parameter</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.Parameter
	 * @generated
	 */
	EClass getParameter();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dml.mm.applicationlevel.repository.Parameter#getDataType <em>Data Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Data Type</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.Parameter#getDataType()
	 * @see #getParameter()
	 * @generated
	 */
	EReference getParameter_DataType();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.repository.Repository <em>Repository</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Repository</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.Repository
	 * @generated
	 */
	EClass getRepository();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dml.mm.applicationlevel.repository.Repository#getImports <em>Imports</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Imports</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.Repository#getImports()
	 * @see #getRepository()
	 * @generated
	 */
	EReference getRepository_Imports();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dml.mm.applicationlevel.repository.Repository#getDatatypes <em>Datatypes</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Datatypes</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.Repository#getDatatypes()
	 * @see #getRepository()
	 * @generated
	 */
	EReference getRepository_Datatypes();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dml.mm.applicationlevel.repository.Repository#getInterfaces <em>Interfaces</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Interfaces</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.Repository#getInterfaces()
	 * @see #getRepository()
	 * @generated
	 */
	EReference getRepository_Interfaces();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dml.mm.applicationlevel.repository.Repository#getComponents <em>Components</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Components</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.Repository#getComponents()
	 * @see #getRepository()
	 * @generated
	 */
	EReference getRepository_Components();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.repository.RepositoryComponent <em>Component</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Component</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.RepositoryComponent
	 * @generated
	 */
	EClass getRepositoryComponent();

	/**
	 * Returns the meta object for the container reference '{@link tools.descartes.dml.mm.applicationlevel.repository.RepositoryComponent#getRepository <em>Repository</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Repository</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.RepositoryComponent#getRepository()
	 * @see #getRepositoryComponent()
	 * @generated
	 */
	EReference getRepositoryComponent_Repository();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.repository.BasicComponent <em>Basic Component</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Basic Component</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.BasicComponent
	 * @generated
	 */
	EClass getBasicComponent();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dml.mm.applicationlevel.repository.BasicComponent#getSemaphores <em>Semaphores</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Semaphores</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.BasicComponent#getSemaphores()
	 * @see #getBasicComponent()
	 * @generated
	 */
	EReference getBasicComponent_Semaphores();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dml.mm.applicationlevel.repository.BasicComponent#getFineGrainedBehavior <em>Fine Grained Behavior</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Fine Grained Behavior</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.BasicComponent#getFineGrainedBehavior()
	 * @see #getBasicComponent()
	 * @generated
	 */
	EReference getBasicComponent_FineGrainedBehavior();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.repository.Semaphore <em>Semaphore</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Semaphore</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.Semaphore
	 * @generated
	 */
	EClass getSemaphore();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dml.mm.applicationlevel.repository.Semaphore#getCapacity <em>Capacity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Capacity</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.Semaphore#getCapacity()
	 * @see #getSemaphore()
	 * @generated
	 */
	EAttribute getSemaphore_Capacity();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.repository.CompositeComponent <em>Composite Component</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Composite Component</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.CompositeComponent
	 * @generated
	 */
	EClass getCompositeComponent();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.repository.SubSystem <em>Sub System</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Sub System</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.SubSystem
	 * @generated
	 */
	EClass getSubSystem();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.repository.DataType <em>Data Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Data Type</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.DataType
	 * @generated
	 */
	EClass getDataType();

	/**
	 * Returns the meta object for the container reference '{@link tools.descartes.dml.mm.applicationlevel.repository.DataType#getRepository <em>Repository</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Repository</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.DataType#getRepository()
	 * @see #getDataType()
	 * @generated
	 */
	EReference getDataType_Repository();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.repository.CollectionDataType <em>Collection Data Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Collection Data Type</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.CollectionDataType
	 * @generated
	 */
	EClass getCollectionDataType();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dml.mm.applicationlevel.repository.CollectionDataType#getInnerType <em>Inner Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Inner Type</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.CollectionDataType#getInnerType()
	 * @see #getCollectionDataType()
	 * @generated
	 */
	EReference getCollectionDataType_InnerType();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.repository.CompositeDataType <em>Composite Data Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Composite Data Type</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.CompositeDataType
	 * @generated
	 */
	EClass getCompositeDataType();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dml.mm.applicationlevel.repository.CompositeDataType#getInnerDeclarations <em>Inner Declarations</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Inner Declarations</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.CompositeDataType#getInnerDeclarations()
	 * @see #getCompositeDataType()
	 * @generated
	 */
	EReference getCompositeDataType_InnerDeclarations();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dml.mm.applicationlevel.repository.CompositeDataType#getParentTypes <em>Parent Types</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Parent Types</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.CompositeDataType#getParentTypes()
	 * @see #getCompositeDataType()
	 * @generated
	 */
	EReference getCompositeDataType_ParentTypes();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.repository.InnerDeclaration <em>Inner Declaration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Inner Declaration</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.InnerDeclaration
	 * @generated
	 */
	EClass getInnerDeclaration();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dml.mm.applicationlevel.repository.InnerDeclaration#getDataType <em>Data Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Data Type</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.InnerDeclaration#getDataType()
	 * @see #getInnerDeclaration()
	 * @generated
	 */
	EReference getInnerDeclaration_DataType();

	/**
	 * Returns the meta object for the container reference '{@link tools.descartes.dml.mm.applicationlevel.repository.InnerDeclaration#getCompositeDataType <em>Composite Data Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Composite Data Type</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.InnerDeclaration#getCompositeDataType()
	 * @see #getInnerDeclaration()
	 * @generated
	 */
	EReference getInnerDeclaration_CompositeDataType();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.repository.PrimitiveDataType <em>Primitive Data Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Primitive Data Type</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.PrimitiveDataType
	 * @generated
	 */
	EClass getPrimitiveDataType();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dml.mm.applicationlevel.repository.PrimitiveDataType#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.PrimitiveDataType#getType()
	 * @see #getPrimitiveDataType()
	 * @generated
	 */
	EAttribute getPrimitiveDataType_Type();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.repository.AssemblyContext <em>Assembly Context</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Assembly Context</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.AssemblyContext
	 * @generated
	 */
	EClass getAssemblyContext();

	/**
	 * Returns the meta object for the container reference '{@link tools.descartes.dml.mm.applicationlevel.repository.AssemblyContext#getParentStructure <em>Parent Structure</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Parent Structure</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.AssemblyContext#getParentStructure()
	 * @see #getAssemblyContext()
	 * @generated
	 */
	EReference getAssemblyContext_ParentStructure();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dml.mm.applicationlevel.repository.AssemblyContext#getEncapsulatedComponent <em>Encapsulated Component</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Encapsulated Component</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.AssemblyContext#getEncapsulatedComponent()
	 * @see #getAssemblyContext()
	 * @generated
	 */
	EReference getAssemblyContext_EncapsulatedComponent();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.repository.AssemblyConnector <em>Assembly Connector</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Assembly Connector</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.AssemblyConnector
	 * @generated
	 */
	EClass getAssemblyConnector();

	/**
	 * Returns the meta object for the container reference '{@link tools.descartes.dml.mm.applicationlevel.repository.AssemblyConnector#getParentStructure <em>Parent Structure</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Parent Structure</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.AssemblyConnector#getParentStructure()
	 * @see #getAssemblyConnector()
	 * @generated
	 */
	EReference getAssemblyConnector_ParentStructure();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dml.mm.applicationlevel.repository.AssemblyConnector#getInterfaceRequiringRole <em>Interface Requiring Role</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Interface Requiring Role</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.AssemblyConnector#getInterfaceRequiringRole()
	 * @see #getAssemblyConnector()
	 * @generated
	 */
	EReference getAssemblyConnector_InterfaceRequiringRole();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dml.mm.applicationlevel.repository.AssemblyConnector#getInterfaceProvidingRole <em>Interface Providing Role</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Interface Providing Role</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.AssemblyConnector#getInterfaceProvidingRole()
	 * @see #getAssemblyConnector()
	 * @generated
	 */
	EReference getAssemblyConnector_InterfaceProvidingRole();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dml.mm.applicationlevel.repository.AssemblyConnector#getProvidingAssemblyContext <em>Providing Assembly Context</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Providing Assembly Context</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.AssemblyConnector#getProvidingAssemblyContext()
	 * @see #getAssemblyConnector()
	 * @generated
	 */
	EReference getAssemblyConnector_ProvidingAssemblyContext();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dml.mm.applicationlevel.repository.AssemblyConnector#getRequiringAssemblyContext <em>Requiring Assembly Context</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Requiring Assembly Context</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.AssemblyConnector#getRequiringAssemblyContext()
	 * @see #getAssemblyConnector()
	 * @generated
	 */
	EReference getAssemblyConnector_RequiringAssemblyContext();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.repository.DelegationConnector <em>Delegation Connector</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Delegation Connector</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.DelegationConnector
	 * @generated
	 */
	EClass getDelegationConnector();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dml.mm.applicationlevel.repository.DelegationConnector#getAssemblyContext <em>Assembly Context</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Assembly Context</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.DelegationConnector#getAssemblyContext()
	 * @see #getDelegationConnector()
	 * @generated
	 */
	EReference getDelegationConnector_AssemblyContext();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.repository.ProvidingDelegationConnector <em>Providing Delegation Connector</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Providing Delegation Connector</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.ProvidingDelegationConnector
	 * @generated
	 */
	EClass getProvidingDelegationConnector();

	/**
	 * Returns the meta object for the container reference '{@link tools.descartes.dml.mm.applicationlevel.repository.ProvidingDelegationConnector#getParentStructure <em>Parent Structure</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Parent Structure</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.ProvidingDelegationConnector#getParentStructure()
	 * @see #getProvidingDelegationConnector()
	 * @generated
	 */
	EReference getProvidingDelegationConnector_ParentStructure();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dml.mm.applicationlevel.repository.ProvidingDelegationConnector#getInnerInterfaceProvidingRole <em>Inner Interface Providing Role</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Inner Interface Providing Role</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.ProvidingDelegationConnector#getInnerInterfaceProvidingRole()
	 * @see #getProvidingDelegationConnector()
	 * @generated
	 */
	EReference getProvidingDelegationConnector_InnerInterfaceProvidingRole();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dml.mm.applicationlevel.repository.ProvidingDelegationConnector#getOuterInterfaceProvidingRole <em>Outer Interface Providing Role</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Outer Interface Providing Role</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.ProvidingDelegationConnector#getOuterInterfaceProvidingRole()
	 * @see #getProvidingDelegationConnector()
	 * @generated
	 */
	EReference getProvidingDelegationConnector_OuterInterfaceProvidingRole();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.repository.RequiringDelegationConnector <em>Requiring Delegation Connector</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Requiring Delegation Connector</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.RequiringDelegationConnector
	 * @generated
	 */
	EClass getRequiringDelegationConnector();

	/**
	 * Returns the meta object for the container reference '{@link tools.descartes.dml.mm.applicationlevel.repository.RequiringDelegationConnector#getParentStructure <em>Parent Structure</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Parent Structure</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.RequiringDelegationConnector#getParentStructure()
	 * @see #getRequiringDelegationConnector()
	 * @generated
	 */
	EReference getRequiringDelegationConnector_ParentStructure();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dml.mm.applicationlevel.repository.RequiringDelegationConnector#getInnerInterfaceRequiringRole <em>Inner Interface Requiring Role</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Inner Interface Requiring Role</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.RequiringDelegationConnector#getInnerInterfaceRequiringRole()
	 * @see #getRequiringDelegationConnector()
	 * @generated
	 */
	EReference getRequiringDelegationConnector_InnerInterfaceRequiringRole();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dml.mm.applicationlevel.repository.RequiringDelegationConnector#getOuterInterfaceRequiringRole <em>Outer Interface Requiring Role</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Outer Interface Requiring Role</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.RequiringDelegationConnector#getOuterInterfaceRequiringRole()
	 * @see #getRequiringDelegationConnector()
	 * @generated
	 */
	EReference getRequiringDelegationConnector_OuterInterfaceRequiringRole();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.repository.InputParameter <em>Input Parameter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Input Parameter</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.InputParameter
	 * @generated
	 */
	EClass getInputParameter();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.repository.OutputParameter <em>Output Parameter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Output Parameter</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.OutputParameter
	 * @generated
	 */
	EClass getOutputParameter();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.repository.InputOutputParameter <em>Input Output Parameter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Input Output Parameter</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.InputOutputParameter
	 * @generated
	 */
	EClass getInputOutputParameter();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.repository.Service <em>Service</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Service</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.Service
	 * @generated
	 */
	EClass getService();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dml.mm.applicationlevel.repository.Service#getAmount <em>Amount</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Amount</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.Service#getAmount()
	 * @see #getService()
	 * @generated
	 */
	EAttribute getService_Amount();

	/**
	 * Returns the meta object for enum '{@link tools.descartes.dml.mm.applicationlevel.repository.ParameterModifier <em>Parameter Modifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Parameter Modifier</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.ParameterModifier
	 * @generated
	 */
	EEnum getParameterModifier();

	/**
	 * Returns the meta object for enum '{@link tools.descartes.dml.mm.applicationlevel.repository.PrimitiveTypeEnum <em>Primitive Type Enum</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Primitive Type Enum</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.PrimitiveTypeEnum
	 * @generated
	 */
	EEnum getPrimitiveTypeEnum();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	RepositoryFactory getRepositoryFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.RoleImpl <em>Role</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RoleImpl
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getRole()
		 * @generated
		 */
		EClass ROLE = eINSTANCE.getRole();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.InterfaceProvidingEntityImpl <em>Interface Providing Entity</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.InterfaceProvidingEntityImpl
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getInterfaceProvidingEntity()
		 * @generated
		 */
		EClass INTERFACE_PROVIDING_ENTITY = eINSTANCE.getInterfaceProvidingEntity();

		/**
		 * The meta object literal for the '<em><b>Interface Providing Roles</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INTERFACE_PROVIDING_ENTITY__INTERFACE_PROVIDING_ROLES = eINSTANCE.getInterfaceProvidingEntity_InterfaceProvidingRoles();

		/**
		 * The meta object literal for the '<em><b>Black Box Behavior</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INTERFACE_PROVIDING_ENTITY__BLACK_BOX_BEHAVIOR = eINSTANCE.getInterfaceProvidingEntity_BlackBoxBehavior();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.InterfaceRequiringEntityImpl <em>Interface Requiring Entity</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.InterfaceRequiringEntityImpl
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getInterfaceRequiringEntity()
		 * @generated
		 */
		EClass INTERFACE_REQUIRING_ENTITY = eINSTANCE.getInterfaceRequiringEntity();

		/**
		 * The meta object literal for the '<em><b>Interface Requiring Roles</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INTERFACE_REQUIRING_ENTITY__INTERFACE_REQUIRING_ROLES = eINSTANCE.getInterfaceRequiringEntity_InterfaceRequiringRoles();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.InterfaceProvidingRequiringEntityImpl <em>Interface Providing Requiring Entity</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.InterfaceProvidingRequiringEntityImpl
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getInterfaceProvidingRequiringEntity()
		 * @generated
		 */
		EClass INTERFACE_PROVIDING_REQUIRING_ENTITY = eINSTANCE.getInterfaceProvidingRequiringEntity();

		/**
		 * The meta object literal for the '<em><b>Coarse Grained Behavior</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INTERFACE_PROVIDING_REQUIRING_ENTITY__COARSE_GRAINED_BEHAVIOR = eINSTANCE.getInterfaceProvidingRequiringEntity_CoarseGrainedBehavior();

		/**
		 * The meta object literal for the '<em><b>Relationships</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INTERFACE_PROVIDING_REQUIRING_ENTITY__RELATIONSHIPS = eINSTANCE.getInterfaceProvidingRequiringEntity_Relationships();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.ImportImpl <em>Import</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.ImportImpl
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getImport()
		 * @generated
		 */
		EClass IMPORT = eINSTANCE.getImport();

		/**
		 * The meta object literal for the '<em><b>Import URI</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute IMPORT__IMPORT_URI = eINSTANCE.getImport_ImportURI();

		/**
		 * The meta object literal for the '<em><b>Repository</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference IMPORT__REPOSITORY = eINSTANCE.getImport_Repository();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.InterfaceRequiringRoleImpl <em>Interface Requiring Role</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.InterfaceRequiringRoleImpl
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getInterfaceRequiringRole()
		 * @generated
		 */
		EClass INTERFACE_REQUIRING_ROLE = eINSTANCE.getInterfaceRequiringRole();

		/**
		 * The meta object literal for the '<em><b>Interface Requiring Entity</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INTERFACE_REQUIRING_ROLE__INTERFACE_REQUIRING_ENTITY = eINSTANCE.getInterfaceRequiringRole_InterfaceRequiringEntity();

		/**
		 * The meta object literal for the '<em><b>Interface</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INTERFACE_REQUIRING_ROLE__INTERFACE = eINSTANCE.getInterfaceRequiringRole_Interface();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.InterfaceProvidingRoleImpl <em>Interface Providing Role</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.InterfaceProvidingRoleImpl
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getInterfaceProvidingRole()
		 * @generated
		 */
		EClass INTERFACE_PROVIDING_ROLE = eINSTANCE.getInterfaceProvidingRole();

		/**
		 * The meta object literal for the '<em><b>Interface Providing Entity</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INTERFACE_PROVIDING_ROLE__INTERFACE_PROVIDING_ENTITY = eINSTANCE.getInterfaceProvidingRole_InterfaceProvidingEntity();

		/**
		 * The meta object literal for the '<em><b>Interface</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INTERFACE_PROVIDING_ROLE__INTERFACE = eINSTANCE.getInterfaceProvidingRole_Interface();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.ComposedStructureImpl <em>Composed Structure</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.ComposedStructureImpl
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getComposedStructure()
		 * @generated
		 */
		EClass COMPOSED_STRUCTURE = eINSTANCE.getComposedStructure();

		/**
		 * The meta object literal for the '<em><b>Assembly Contexts</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COMPOSED_STRUCTURE__ASSEMBLY_CONTEXTS = eINSTANCE.getComposedStructure_AssemblyContexts();

		/**
		 * The meta object literal for the '<em><b>Assembly Connectors</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COMPOSED_STRUCTURE__ASSEMBLY_CONNECTORS = eINSTANCE.getComposedStructure_AssemblyConnectors();

		/**
		 * The meta object literal for the '<em><b>Providing Delegation Connectors</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COMPOSED_STRUCTURE__PROVIDING_DELEGATION_CONNECTORS = eINSTANCE.getComposedStructure_ProvidingDelegationConnectors();

		/**
		 * The meta object literal for the '<em><b>Requiring Delegation Connectors</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COMPOSED_STRUCTURE__REQUIRING_DELEGATION_CONNECTORS = eINSTANCE.getComposedStructure_RequiringDelegationConnectors();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.ComposedProvidingRequiringEntityImpl <em>Composed Providing Requiring Entity</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.ComposedProvidingRequiringEntityImpl
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getComposedProvidingRequiringEntity()
		 * @generated
		 */
		EClass COMPOSED_PROVIDING_REQUIRING_ENTITY = eINSTANCE.getComposedProvidingRequiringEntity();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.InterfaceImpl <em>Interface</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.InterfaceImpl
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getInterface()
		 * @generated
		 */
		EClass INTERFACE = eINSTANCE.getInterface();

		/**
		 * The meta object literal for the '<em><b>Repository</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INTERFACE__REPOSITORY = eINSTANCE.getInterface_Repository();

		/**
		 * The meta object literal for the '<em><b>Parent Interfaces</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INTERFACE__PARENT_INTERFACES = eINSTANCE.getInterface_ParentInterfaces();

		/**
		 * The meta object literal for the '<em><b>Signatures</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INTERFACE__SIGNATURES = eINSTANCE.getInterface_Signatures();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.SignatureImpl <em>Signature</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.SignatureImpl
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getSignature()
		 * @generated
		 */
		EClass SIGNATURE = eINSTANCE.getSignature();

		/**
		 * The meta object literal for the '<em><b>Parameters</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SIGNATURE__PARAMETERS = eINSTANCE.getSignature_Parameters();

		/**
		 * The meta object literal for the '<em><b>Return Type</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SIGNATURE__RETURN_TYPE = eINSTANCE.getSignature_ReturnType();

		/**
		 * The meta object literal for the '<em><b>Interface</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SIGNATURE__INTERFACE = eINSTANCE.getSignature_Interface();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.ParameterImpl <em>Parameter</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.ParameterImpl
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getParameter()
		 * @generated
		 */
		EClass PARAMETER = eINSTANCE.getParameter();

		/**
		 * The meta object literal for the '<em><b>Data Type</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PARAMETER__DATA_TYPE = eINSTANCE.getParameter_DataType();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryImpl <em>Repository</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryImpl
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getRepository()
		 * @generated
		 */
		EClass REPOSITORY = eINSTANCE.getRepository();

		/**
		 * The meta object literal for the '<em><b>Imports</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference REPOSITORY__IMPORTS = eINSTANCE.getRepository_Imports();

		/**
		 * The meta object literal for the '<em><b>Datatypes</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference REPOSITORY__DATATYPES = eINSTANCE.getRepository_Datatypes();

		/**
		 * The meta object literal for the '<em><b>Interfaces</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference REPOSITORY__INTERFACES = eINSTANCE.getRepository_Interfaces();

		/**
		 * The meta object literal for the '<em><b>Components</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference REPOSITORY__COMPONENTS = eINSTANCE.getRepository_Components();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryComponentImpl <em>Component</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryComponentImpl
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getRepositoryComponent()
		 * @generated
		 */
		EClass REPOSITORY_COMPONENT = eINSTANCE.getRepositoryComponent();

		/**
		 * The meta object literal for the '<em><b>Repository</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference REPOSITORY_COMPONENT__REPOSITORY = eINSTANCE.getRepositoryComponent_Repository();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.BasicComponentImpl <em>Basic Component</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.BasicComponentImpl
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getBasicComponent()
		 * @generated
		 */
		EClass BASIC_COMPONENT = eINSTANCE.getBasicComponent();

		/**
		 * The meta object literal for the '<em><b>Semaphores</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BASIC_COMPONENT__SEMAPHORES = eINSTANCE.getBasicComponent_Semaphores();

		/**
		 * The meta object literal for the '<em><b>Fine Grained Behavior</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BASIC_COMPONENT__FINE_GRAINED_BEHAVIOR = eINSTANCE.getBasicComponent_FineGrainedBehavior();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.SemaphoreImpl <em>Semaphore</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.SemaphoreImpl
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getSemaphore()
		 * @generated
		 */
		EClass SEMAPHORE = eINSTANCE.getSemaphore();

		/**
		 * The meta object literal for the '<em><b>Capacity</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SEMAPHORE__CAPACITY = eINSTANCE.getSemaphore_Capacity();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.CompositeComponentImpl <em>Composite Component</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.CompositeComponentImpl
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getCompositeComponent()
		 * @generated
		 */
		EClass COMPOSITE_COMPONENT = eINSTANCE.getCompositeComponent();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.SubSystemImpl <em>Sub System</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.SubSystemImpl
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getSubSystem()
		 * @generated
		 */
		EClass SUB_SYSTEM = eINSTANCE.getSubSystem();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.DataTypeImpl <em>Data Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.DataTypeImpl
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getDataType()
		 * @generated
		 */
		EClass DATA_TYPE = eINSTANCE.getDataType();

		/**
		 * The meta object literal for the '<em><b>Repository</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DATA_TYPE__REPOSITORY = eINSTANCE.getDataType_Repository();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.CollectionDataTypeImpl <em>Collection Data Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.CollectionDataTypeImpl
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getCollectionDataType()
		 * @generated
		 */
		EClass COLLECTION_DATA_TYPE = eINSTANCE.getCollectionDataType();

		/**
		 * The meta object literal for the '<em><b>Inner Type</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COLLECTION_DATA_TYPE__INNER_TYPE = eINSTANCE.getCollectionDataType_InnerType();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.CompositeDataTypeImpl <em>Composite Data Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.CompositeDataTypeImpl
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getCompositeDataType()
		 * @generated
		 */
		EClass COMPOSITE_DATA_TYPE = eINSTANCE.getCompositeDataType();

		/**
		 * The meta object literal for the '<em><b>Inner Declarations</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COMPOSITE_DATA_TYPE__INNER_DECLARATIONS = eINSTANCE.getCompositeDataType_InnerDeclarations();

		/**
		 * The meta object literal for the '<em><b>Parent Types</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COMPOSITE_DATA_TYPE__PARENT_TYPES = eINSTANCE.getCompositeDataType_ParentTypes();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.InnerDeclarationImpl <em>Inner Declaration</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.InnerDeclarationImpl
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getInnerDeclaration()
		 * @generated
		 */
		EClass INNER_DECLARATION = eINSTANCE.getInnerDeclaration();

		/**
		 * The meta object literal for the '<em><b>Data Type</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INNER_DECLARATION__DATA_TYPE = eINSTANCE.getInnerDeclaration_DataType();

		/**
		 * The meta object literal for the '<em><b>Composite Data Type</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INNER_DECLARATION__COMPOSITE_DATA_TYPE = eINSTANCE.getInnerDeclaration_CompositeDataType();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.PrimitiveDataTypeImpl <em>Primitive Data Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.PrimitiveDataTypeImpl
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getPrimitiveDataType()
		 * @generated
		 */
		EClass PRIMITIVE_DATA_TYPE = eINSTANCE.getPrimitiveDataType();

		/**
		 * The meta object literal for the '<em><b>Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PRIMITIVE_DATA_TYPE__TYPE = eINSTANCE.getPrimitiveDataType_Type();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.AssemblyContextImpl <em>Assembly Context</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.AssemblyContextImpl
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getAssemblyContext()
		 * @generated
		 */
		EClass ASSEMBLY_CONTEXT = eINSTANCE.getAssemblyContext();

		/**
		 * The meta object literal for the '<em><b>Parent Structure</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ASSEMBLY_CONTEXT__PARENT_STRUCTURE = eINSTANCE.getAssemblyContext_ParentStructure();

		/**
		 * The meta object literal for the '<em><b>Encapsulated Component</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ASSEMBLY_CONTEXT__ENCAPSULATED_COMPONENT = eINSTANCE.getAssemblyContext_EncapsulatedComponent();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.AssemblyConnectorImpl <em>Assembly Connector</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.AssemblyConnectorImpl
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getAssemblyConnector()
		 * @generated
		 */
		EClass ASSEMBLY_CONNECTOR = eINSTANCE.getAssemblyConnector();

		/**
		 * The meta object literal for the '<em><b>Parent Structure</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ASSEMBLY_CONNECTOR__PARENT_STRUCTURE = eINSTANCE.getAssemblyConnector_ParentStructure();

		/**
		 * The meta object literal for the '<em><b>Interface Requiring Role</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ASSEMBLY_CONNECTOR__INTERFACE_REQUIRING_ROLE = eINSTANCE.getAssemblyConnector_InterfaceRequiringRole();

		/**
		 * The meta object literal for the '<em><b>Interface Providing Role</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ASSEMBLY_CONNECTOR__INTERFACE_PROVIDING_ROLE = eINSTANCE.getAssemblyConnector_InterfaceProvidingRole();

		/**
		 * The meta object literal for the '<em><b>Providing Assembly Context</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ASSEMBLY_CONNECTOR__PROVIDING_ASSEMBLY_CONTEXT = eINSTANCE.getAssemblyConnector_ProvidingAssemblyContext();

		/**
		 * The meta object literal for the '<em><b>Requiring Assembly Context</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ASSEMBLY_CONNECTOR__REQUIRING_ASSEMBLY_CONTEXT = eINSTANCE.getAssemblyConnector_RequiringAssemblyContext();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.DelegationConnectorImpl <em>Delegation Connector</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.DelegationConnectorImpl
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getDelegationConnector()
		 * @generated
		 */
		EClass DELEGATION_CONNECTOR = eINSTANCE.getDelegationConnector();

		/**
		 * The meta object literal for the '<em><b>Assembly Context</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DELEGATION_CONNECTOR__ASSEMBLY_CONTEXT = eINSTANCE.getDelegationConnector_AssemblyContext();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.ProvidingDelegationConnectorImpl <em>Providing Delegation Connector</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.ProvidingDelegationConnectorImpl
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getProvidingDelegationConnector()
		 * @generated
		 */
		EClass PROVIDING_DELEGATION_CONNECTOR = eINSTANCE.getProvidingDelegationConnector();

		/**
		 * The meta object literal for the '<em><b>Parent Structure</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROVIDING_DELEGATION_CONNECTOR__PARENT_STRUCTURE = eINSTANCE.getProvidingDelegationConnector_ParentStructure();

		/**
		 * The meta object literal for the '<em><b>Inner Interface Providing Role</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROVIDING_DELEGATION_CONNECTOR__INNER_INTERFACE_PROVIDING_ROLE = eINSTANCE.getProvidingDelegationConnector_InnerInterfaceProvidingRole();

		/**
		 * The meta object literal for the '<em><b>Outer Interface Providing Role</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROVIDING_DELEGATION_CONNECTOR__OUTER_INTERFACE_PROVIDING_ROLE = eINSTANCE.getProvidingDelegationConnector_OuterInterfaceProvidingRole();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.RequiringDelegationConnectorImpl <em>Requiring Delegation Connector</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RequiringDelegationConnectorImpl
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getRequiringDelegationConnector()
		 * @generated
		 */
		EClass REQUIRING_DELEGATION_CONNECTOR = eINSTANCE.getRequiringDelegationConnector();

		/**
		 * The meta object literal for the '<em><b>Parent Structure</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference REQUIRING_DELEGATION_CONNECTOR__PARENT_STRUCTURE = eINSTANCE.getRequiringDelegationConnector_ParentStructure();

		/**
		 * The meta object literal for the '<em><b>Inner Interface Requiring Role</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference REQUIRING_DELEGATION_CONNECTOR__INNER_INTERFACE_REQUIRING_ROLE = eINSTANCE.getRequiringDelegationConnector_InnerInterfaceRequiringRole();

		/**
		 * The meta object literal for the '<em><b>Outer Interface Requiring Role</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference REQUIRING_DELEGATION_CONNECTOR__OUTER_INTERFACE_REQUIRING_ROLE = eINSTANCE.getRequiringDelegationConnector_OuterInterfaceRequiringRole();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.InputParameterImpl <em>Input Parameter</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.InputParameterImpl
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getInputParameter()
		 * @generated
		 */
		EClass INPUT_PARAMETER = eINSTANCE.getInputParameter();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.OutputParameterImpl <em>Output Parameter</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.OutputParameterImpl
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getOutputParameter()
		 * @generated
		 */
		EClass OUTPUT_PARAMETER = eINSTANCE.getOutputParameter();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.InputOutputParameterImpl <em>Input Output Parameter</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.InputOutputParameterImpl
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getInputOutputParameter()
		 * @generated
		 */
		EClass INPUT_OUTPUT_PARAMETER = eINSTANCE.getInputOutputParameter();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.repository.impl.ServiceImpl <em>Service</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.ServiceImpl
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getService()
		 * @generated
		 */
		EClass SERVICE = eINSTANCE.getService();

		/**
		 * The meta object literal for the '<em><b>Amount</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SERVICE__AMOUNT = eINSTANCE.getService_Amount();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.repository.ParameterModifier <em>Parameter Modifier</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.repository.ParameterModifier
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getParameterModifier()
		 * @generated
		 */
		EEnum PARAMETER_MODIFIER = eINSTANCE.getParameterModifier();

		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.repository.PrimitiveTypeEnum <em>Primitive Type Enum</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.repository.PrimitiveTypeEnum
		 * @see tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl#getPrimitiveTypeEnum()
		 * @generated
		 */
		EEnum PRIMITIVE_TYPE_ENUM = eINSTANCE.getPrimitiveTypeEnum();

	}

} //RepositoryPackage
