/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package tools.descartes.dml.mm.applicationlevel.servicebehavior.util;

import java.util.Map;

import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.ResourceLocator;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.util.EObjectValidator;

import tools.descartes.dml.mm.applicationlevel.parameterdependencies.util.ParameterdependenciesValidator;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.AbstractAction;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.AcquireAction;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.BlackBoxBehavior;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.BranchAction;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.BranchProbabilities;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.CallFrequency;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.CoarseGrainedBehavior;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.ComponentInternalBehavior;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.ExternalCall;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.ExternalCallAction;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.ExternalCallFrequency;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.FineGrainedBehavior;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.ForkAction;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.InternalAction;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.LoopAction;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.LoopIterationCount;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.RelationshipVariable;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.ReleaseAction;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.ResourceDemand;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.ResponseTime;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.ServiceBehaviorAbstraction;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.ServicebehaviorPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Validator</b> for the model.
 * <!-- end-user-doc -->
 * @see tools.descartes.dml.mm.applicationlevel.servicebehavior.ServicebehaviorPackage
 * @generated
 */
public class ServicebehaviorValidator extends EObjectValidator {
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final ServicebehaviorValidator INSTANCE = new ServicebehaviorValidator();

	/**
	 * A constant for the {@link org.eclipse.emf.common.util.Diagnostic#getSource() source} of diagnostic {@link org.eclipse.emf.common.util.Diagnostic#getCode() codes} from this package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.common.util.Diagnostic#getSource()
	 * @see org.eclipse.emf.common.util.Diagnostic#getCode()
	 * @generated
	 */
	public static final String DIAGNOSTIC_SOURCE = "tools.descartes.dml.mm.applicationlevel.servicebehavior";

	/**
	 * A constant with a fixed name that can be used as the base value for additional hand written constants.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final int GENERATED_DIAGNOSTIC_CODE_COUNT = 0;

	/**
	 * A constant with a fixed name that can be used as the base value for additional hand written constants in a derived class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final int DIAGNOSTIC_CODE_COUNT = GENERATED_DIAGNOSTIC_CODE_COUNT;

	/**
	 * The cached base package validator.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ParameterdependenciesValidator parameterdependenciesValidator;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ServicebehaviorValidator() {
		super();
		parameterdependenciesValidator = ParameterdependenciesValidator.INSTANCE;
	}

	/**
	 * Returns the package of this validator switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EPackage getEPackage() {
	  return ServicebehaviorPackage.eINSTANCE;
	}

	/**
	 * Calls <code>validateXXX</code> for the corresponding classifier of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected boolean validate(int classifierID, Object value, DiagnosticChain diagnostics, Map<Object, Object> context) {
		switch (classifierID) {
			case ServicebehaviorPackage.SERVICE_BEHAVIOR_ABSTRACTION:
				return validateServiceBehaviorAbstraction((ServiceBehaviorAbstraction)value, diagnostics, context);
			case ServicebehaviorPackage.FINE_GRAINED_BEHAVIOR:
				return validateFineGrainedBehavior((FineGrainedBehavior)value, diagnostics, context);
			case ServicebehaviorPackage.COMPONENT_INTERNAL_BEHAVIOR:
				return validateComponentInternalBehavior((ComponentInternalBehavior)value, diagnostics, context);
			case ServicebehaviorPackage.ABSTRACT_ACTION:
				return validateAbstractAction((AbstractAction)value, diagnostics, context);
			case ServicebehaviorPackage.ACQUIRE_ACTION:
				return validateAcquireAction((AcquireAction)value, diagnostics, context);
			case ServicebehaviorPackage.RELEASE_ACTION:
				return validateReleaseAction((ReleaseAction)value, diagnostics, context);
			case ServicebehaviorPackage.INTERNAL_ACTION:
				return validateInternalAction((InternalAction)value, diagnostics, context);
			case ServicebehaviorPackage.FORK_ACTION:
				return validateForkAction((ForkAction)value, diagnostics, context);
			case ServicebehaviorPackage.BRANCH_ACTION:
				return validateBranchAction((BranchAction)value, diagnostics, context);
			case ServicebehaviorPackage.BRANCH_PROBABILITIES:
				return validateBranchProbabilities((BranchProbabilities)value, diagnostics, context);
			case ServicebehaviorPackage.LOOP_ACTION:
				return validateLoopAction((LoopAction)value, diagnostics, context);
			case ServicebehaviorPackage.LOOP_ITERATION_COUNT:
				return validateLoopIterationCount((LoopIterationCount)value, diagnostics, context);
			case ServicebehaviorPackage.EXTERNAL_CALL_ACTION:
				return validateExternalCallAction((ExternalCallAction)value, diagnostics, context);
			case ServicebehaviorPackage.EXTERNAL_CALL:
				return validateExternalCall((ExternalCall)value, diagnostics, context);
			case ServicebehaviorPackage.RESOURCE_DEMAND:
				return validateResourceDemand((ResourceDemand)value, diagnostics, context);
			case ServicebehaviorPackage.COARSE_GRAINED_BEHAVIOR:
				return validateCoarseGrainedBehavior((CoarseGrainedBehavior)value, diagnostics, context);
			case ServicebehaviorPackage.EXTERNAL_CALL_FREQUENCY:
				return validateExternalCallFrequency((ExternalCallFrequency)value, diagnostics, context);
			case ServicebehaviorPackage.CALL_FREQUENCY:
				return validateCallFrequency((CallFrequency)value, diagnostics, context);
			case ServicebehaviorPackage.BLACK_BOX_BEHAVIOR:
				return validateBlackBoxBehavior((BlackBoxBehavior)value, diagnostics, context);
			case ServicebehaviorPackage.RESPONSE_TIME:
				return validateResponseTime((ResponseTime)value, diagnostics, context);
			case ServicebehaviorPackage.RELATIONSHIP_VARIABLE:
				return validateRelationshipVariable((RelationshipVariable)value, diagnostics, context);
			default:
				return true;
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateServiceBehaviorAbstraction(ServiceBehaviorAbstraction serviceBehaviorAbstraction, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment((EObject)serviceBehaviorAbstraction, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms((EObject)serviceBehaviorAbstraction, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms((EObject)serviceBehaviorAbstraction, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained((EObject)serviceBehaviorAbstraction, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired((EObject)serviceBehaviorAbstraction, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves((EObject)serviceBehaviorAbstraction, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID((EObject)serviceBehaviorAbstraction, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique((EObject)serviceBehaviorAbstraction, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique((EObject)serviceBehaviorAbstraction, diagnostics, context);
		if (result || diagnostics != null) result &= validateServiceBehaviorAbstraction_DescribedSignatureMustBelongToInterfaceReferencedByInterfaceProvidingRole(serviceBehaviorAbstraction, diagnostics, context);
		return result;
	}

	/**
	 * The cached validation expression for the DescribedSignatureMustBelongToInterfaceReferencedByInterfaceProvidingRole constraint of '<em>Service Behavior Abstraction</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final String SERVICE_BEHAVIOR_ABSTRACTION__DESCRIBED_SIGNATURE_MUST_BELONG_TO_INTERFACE_REFERENCED_BY_INTERFACE_PROVIDING_ROLE__EEXPRESSION = "\n" +
		"\t\t\tself.interfaceProvidingRole.interface.signatures->exists(sign|sign=self.describedSignature)";

	/**
	 * Validates the DescribedSignatureMustBelongToInterfaceReferencedByInterfaceProvidingRole constraint of '<em>Service Behavior Abstraction</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateServiceBehaviorAbstraction_DescribedSignatureMustBelongToInterfaceReferencedByInterfaceProvidingRole(ServiceBehaviorAbstraction serviceBehaviorAbstraction, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(ServicebehaviorPackage.Literals.SERVICE_BEHAVIOR_ABSTRACTION,
				 (EObject)serviceBehaviorAbstraction,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "DescribedSignatureMustBelongToInterfaceReferencedByInterfaceProvidingRole",
				 SERVICE_BEHAVIOR_ABSTRACTION__DESCRIBED_SIGNATURE_MUST_BELONG_TO_INTERFACE_REFERENCED_BY_INTERFACE_PROVIDING_ROLE__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateFineGrainedBehavior(FineGrainedBehavior fineGrainedBehavior, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment((EObject)fineGrainedBehavior, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms((EObject)fineGrainedBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms((EObject)fineGrainedBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained((EObject)fineGrainedBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired((EObject)fineGrainedBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves((EObject)fineGrainedBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID((EObject)fineGrainedBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique((EObject)fineGrainedBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique((EObject)fineGrainedBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validateServiceBehaviorAbstraction_DescribedSignatureMustBelongToInterfaceReferencedByInterfaceProvidingRole(fineGrainedBehavior, diagnostics, context);
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateComponentInternalBehavior(ComponentInternalBehavior componentInternalBehavior, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint((EObject)componentInternalBehavior, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateAbstractAction(AbstractAction abstractAction, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint((EObject)abstractAction, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateAcquireAction(AcquireAction acquireAction, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint((EObject)acquireAction, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateReleaseAction(ReleaseAction releaseAction, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint((EObject)releaseAction, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateInternalAction(InternalAction internalAction, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint((EObject)internalAction, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateForkAction(ForkAction forkAction, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint((EObject)forkAction, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateBranchAction(BranchAction branchAction, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint((EObject)branchAction, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateBranchProbabilities(BranchProbabilities branchProbabilities, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment((EObject)branchProbabilities, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms((EObject)branchProbabilities, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms((EObject)branchProbabilities, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained((EObject)branchProbabilities, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired((EObject)branchProbabilities, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves((EObject)branchProbabilities, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID((EObject)branchProbabilities, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique((EObject)branchProbabilities, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique((EObject)branchProbabilities, diagnostics, context);
		if (result || diagnostics != null) result &= parameterdependenciesValidator.validateControlFlowVariable_EnforceExplicitDescriptionWhenExplicitCharacterizationType(branchProbabilities, diagnostics, context);
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateLoopAction(LoopAction loopAction, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint((EObject)loopAction, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateLoopIterationCount(LoopIterationCount loopIterationCount, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment((EObject)loopIterationCount, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms((EObject)loopIterationCount, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms((EObject)loopIterationCount, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained((EObject)loopIterationCount, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired((EObject)loopIterationCount, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves((EObject)loopIterationCount, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID((EObject)loopIterationCount, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique((EObject)loopIterationCount, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique((EObject)loopIterationCount, diagnostics, context);
		if (result || diagnostics != null) result &= parameterdependenciesValidator.validateControlFlowVariable_EnforceExplicitDescriptionWhenExplicitCharacterizationType(loopIterationCount, diagnostics, context);
		if (result || diagnostics != null) result &= validateLoopIterationCount_LoopIterationCountHasToBeInt(loopIterationCount, diagnostics, context);
		return result;
	}

	/**
	 * The cached validation expression for the LoopIterationCountHasToBeInt constraint of '<em>Loop Iteration Count</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final String LOOP_ITERATION_COUNT__LOOP_ITERATION_COUNT_HAS_TO_BE_INT__EEXPRESSION = "self.explicitDescription.oclIsUndefined() or\r\n" +
		"self.explicitDescription.probFunction.oclIsUndefined() or\r\n" +
		"self.explicitDescription.probFunction.oclIsTypeOf(functions::IntLiteral) or\r\n" +
		"(self.explicitDescription.probFunction.oclIsTypeOf(functions::ProbabilityMassFunction) and\r\n" +
		" self.explicitDescription.probFunction.oclAsType(functions::ProbabilityMassFunction).samples.oclIsTypeOf(functions::IntSampleList))";

	/**
	 * Validates the LoopIterationCountHasToBeInt constraint of '<em>Loop Iteration Count</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateLoopIterationCount_LoopIterationCountHasToBeInt(LoopIterationCount loopIterationCount, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(ServicebehaviorPackage.Literals.LOOP_ITERATION_COUNT,
				 (EObject)loopIterationCount,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "LoopIterationCountHasToBeInt",
				 LOOP_ITERATION_COUNT__LOOP_ITERATION_COUNT_HAS_TO_BE_INT__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateExternalCallAction(ExternalCallAction externalCallAction, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint((EObject)externalCallAction, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateExternalCall(ExternalCall externalCall, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment((EObject)externalCall, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms((EObject)externalCall, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms((EObject)externalCall, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained((EObject)externalCall, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired((EObject)externalCall, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves((EObject)externalCall, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID((EObject)externalCall, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique((EObject)externalCall, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique((EObject)externalCall, diagnostics, context);
		if (result || diagnostics != null) result &= validateExternalCall_SignatureBelongsToInterfaceRequiringRole(externalCall, diagnostics, context);
		return result;
	}

	/**
	 * The cached validation expression for the SignatureBelongsToInterfaceRequiringRole constraint of '<em>External Call</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final String EXTERNAL_CALL__SIGNATURE_BELONGS_TO_INTERFACE_REQUIRING_ROLE__EEXPRESSION = "\n" +
		"\t\t\tself.interfaceRequiringRole.interface.signatures->includes(self.signature)";

	/**
	 * Validates the SignatureBelongsToInterfaceRequiringRole constraint of '<em>External Call</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateExternalCall_SignatureBelongsToInterfaceRequiringRole(ExternalCall externalCall, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(ServicebehaviorPackage.Literals.EXTERNAL_CALL,
				 (EObject)externalCall,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "SignatureBelongsToInterfaceRequiringRole",
				 EXTERNAL_CALL__SIGNATURE_BELONGS_TO_INTERFACE_REQUIRING_ROLE__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateResourceDemand(ResourceDemand resourceDemand, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment((EObject)resourceDemand, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms((EObject)resourceDemand, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms((EObject)resourceDemand, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained((EObject)resourceDemand, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired((EObject)resourceDemand, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves((EObject)resourceDemand, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID((EObject)resourceDemand, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique((EObject)resourceDemand, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique((EObject)resourceDemand, diagnostics, context);
		if (result || diagnostics != null) result &= validateResourceDemand_EnforceExplicitDescriptionWhenExplicitCharacterizationType(resourceDemand, diagnostics, context);
		return result;
	}

	/**
	 * The cached validation expression for the EnforceExplicitDescriptionWhenExplicitCharacterizationType constraint of '<em>Resource Demand</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final String RESOURCE_DEMAND__ENFORCE_EXPLICIT_DESCRIPTION_WHEN_EXPLICIT_CHARACTERIZATION_TYPE__EEXPRESSION = "\n" +
		"\t\t   self.characterization = parameterdependencies::RelationshipCharacterizationType::EXPLICIT implies explicitDescription <> null";

	/**
	 * Validates the EnforceExplicitDescriptionWhenExplicitCharacterizationType constraint of '<em>Resource Demand</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateResourceDemand_EnforceExplicitDescriptionWhenExplicitCharacterizationType(ResourceDemand resourceDemand, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(ServicebehaviorPackage.Literals.RESOURCE_DEMAND,
				 (EObject)resourceDemand,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "EnforceExplicitDescriptionWhenExplicitCharacterizationType",
				 RESOURCE_DEMAND__ENFORCE_EXPLICIT_DESCRIPTION_WHEN_EXPLICIT_CHARACTERIZATION_TYPE__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateCoarseGrainedBehavior(CoarseGrainedBehavior coarseGrainedBehavior, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment((EObject)coarseGrainedBehavior, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms((EObject)coarseGrainedBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms((EObject)coarseGrainedBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained((EObject)coarseGrainedBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired((EObject)coarseGrainedBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves((EObject)coarseGrainedBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID((EObject)coarseGrainedBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique((EObject)coarseGrainedBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique((EObject)coarseGrainedBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validateServiceBehaviorAbstraction_DescribedSignatureMustBelongToInterfaceReferencedByInterfaceProvidingRole(coarseGrainedBehavior, diagnostics, context);
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateExternalCallFrequency(ExternalCallFrequency externalCallFrequency, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint((EObject)externalCallFrequency, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateCallFrequency(CallFrequency callFrequency, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment((EObject)callFrequency, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms((EObject)callFrequency, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms((EObject)callFrequency, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained((EObject)callFrequency, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired((EObject)callFrequency, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves((EObject)callFrequency, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID((EObject)callFrequency, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique((EObject)callFrequency, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique((EObject)callFrequency, diagnostics, context);
		if (result || diagnostics != null) result &= parameterdependenciesValidator.validateControlFlowVariable_EnforceExplicitDescriptionWhenExplicitCharacterizationType(callFrequency, diagnostics, context);
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateBlackBoxBehavior(BlackBoxBehavior blackBoxBehavior, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment((EObject)blackBoxBehavior, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms((EObject)blackBoxBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms((EObject)blackBoxBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained((EObject)blackBoxBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired((EObject)blackBoxBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves((EObject)blackBoxBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID((EObject)blackBoxBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique((EObject)blackBoxBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique((EObject)blackBoxBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validateServiceBehaviorAbstraction_DescribedSignatureMustBelongToInterfaceReferencedByInterfaceProvidingRole(blackBoxBehavior, diagnostics, context);
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateResponseTime(ResponseTime responseTime, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment((EObject)responseTime, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms((EObject)responseTime, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms((EObject)responseTime, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained((EObject)responseTime, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired((EObject)responseTime, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves((EObject)responseTime, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID((EObject)responseTime, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique((EObject)responseTime, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique((EObject)responseTime, diagnostics, context);
		if (result || diagnostics != null) result &= validateResponseTime_EnforceExplicitDescriptionWhenExplicitCharacterizationType(responseTime, diagnostics, context);
		return result;
	}

	/**
	 * The cached validation expression for the EnforceExplicitDescriptionWhenExplicitCharacterizationType constraint of '<em>Response Time</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final String RESPONSE_TIME__ENFORCE_EXPLICIT_DESCRIPTION_WHEN_EXPLICIT_CHARACTERIZATION_TYPE__EEXPRESSION = "\n" +
		"\t\t\tself.characterization = parameterdependencies::RelationshipCharacterizationType::EXPLICIT implies explicitDescription <> null";

	/**
	 * Validates the EnforceExplicitDescriptionWhenExplicitCharacterizationType constraint of '<em>Response Time</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateResponseTime_EnforceExplicitDescriptionWhenExplicitCharacterizationType(ResponseTime responseTime, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(ServicebehaviorPackage.Literals.RESPONSE_TIME,
				 (EObject)responseTime,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "EnforceExplicitDescriptionWhenExplicitCharacterizationType",
				 RESPONSE_TIME__ENFORCE_EXPLICIT_DESCRIPTION_WHEN_EXPLICIT_CHARACTERIZATION_TYPE__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateRelationshipVariable(RelationshipVariable relationshipVariable, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint((EObject)relationshipVariable, diagnostics, context);
	}

	/**
	 * Returns the resource locator that will be used to fetch messages for this validator's diagnostics.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ResourceLocator getResourceLocator() {
		// TODO
		// Specialize this to return a resource locator for messages specific to this validator.
		// Ensure that you remove @generated or mark it @generated NOT
		return super.getResourceLocator();
	}

} //ServicebehaviorValidator
