/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package tools.descartes.dml.mm.deployment;

import org.eclipse.emf.common.util.EList;

import tools.descartes.dml.core.Entity;
import tools.descartes.dml.mm.resourcelandscape.DistributedDataCenter;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Deployment</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dml.mm.deployment.Deployment#getSystem <em>System</em>}</li>
 *   <li>{@link tools.descartes.dml.mm.deployment.Deployment#getTargetResourceLandscape <em>Target Resource Landscape</em>}</li>
 *   <li>{@link tools.descartes.dml.mm.deployment.Deployment#getDeploymentContexts <em>Deployment Contexts</em>}</li>
 *   <li>{@link tools.descartes.dml.mm.deployment.Deployment#getDeploymentStrategies <em>Deployment Strategies</em>}</li>
 * </ul>
 *
 * @see tools.descartes.dml.mm.deployment.DeploymentPackage#getDeployment()
 * @model
 * @generated
 */
public interface Deployment extends Entity {
	/**
	 * Returns the value of the '<em><b>System</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>System</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>System</em>' reference.
	 * @see #setSystem(tools.descartes.dml.mm.applicationlevel.system.System)
	 * @see tools.descartes.dml.mm.deployment.DeploymentPackage#getDeployment_System()
	 * @model required="true" ordered="false"
	 * @generated
	 */
	tools.descartes.dml.mm.applicationlevel.system.System getSystem();

	/**
	 * Sets the value of the '{@link tools.descartes.dml.mm.deployment.Deployment#getSystem <em>System</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>System</em>' reference.
	 * @see #getSystem()
	 * @generated
	 */
	void setSystem(tools.descartes.dml.mm.applicationlevel.system.System value);

	/**
	 * Returns the value of the '<em><b>Target Resource Landscape</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Target Resource Landscape</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Target Resource Landscape</em>' reference.
	 * @see #setTargetResourceLandscape(DistributedDataCenter)
	 * @see tools.descartes.dml.mm.deployment.DeploymentPackage#getDeployment_TargetResourceLandscape()
	 * @model required="true" ordered="false"
	 * @generated
	 */
	DistributedDataCenter getTargetResourceLandscape();

	/**
	 * Sets the value of the '{@link tools.descartes.dml.mm.deployment.Deployment#getTargetResourceLandscape <em>Target Resource Landscape</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Target Resource Landscape</em>' reference.
	 * @see #getTargetResourceLandscape()
	 * @generated
	 */
	void setTargetResourceLandscape(DistributedDataCenter value);

	/**
	 * Returns the value of the '<em><b>Deployment Contexts</b></em>' containment reference list.
	 * The list contents are of type {@link tools.descartes.dml.mm.deployment.DeploymentContext}.
	 * It is bidirectional and its opposite is '{@link tools.descartes.dml.mm.deployment.DeploymentContext#getDeployment <em>Deployment</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Deployment Contexts</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Deployment Contexts</em>' containment reference list.
	 * @see tools.descartes.dml.mm.deployment.DeploymentPackage#getDeployment_DeploymentContexts()
	 * @see tools.descartes.dml.mm.deployment.DeploymentContext#getDeployment
	 * @model opposite="deployment" containment="true" resolveProxies="true" ordered="false"
	 * @generated
	 */
	EList<DeploymentContext> getDeploymentContexts();

	/**
	 * Returns the value of the '<em><b>Deployment Strategies</b></em>' containment reference list.
	 * The list contents are of type {@link tools.descartes.dml.mm.deployment.DeploymentStrategy}.
	 * It is bidirectional and its opposite is '{@link tools.descartes.dml.mm.deployment.DeploymentStrategy#getDeployment <em>Deployment</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Deployment Strategies</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Deployment Strategies</em>' containment reference list.
	 * @see tools.descartes.dml.mm.deployment.DeploymentPackage#getDeployment_DeploymentStrategies()
	 * @see tools.descartes.dml.mm.deployment.DeploymentStrategy#getDeployment
	 * @model opposite="deployment" containment="true" resolveProxies="true" ordered="false"
	 * @generated
	 */
	EList<DeploymentStrategy> getDeploymentStrategies();

} // Deployment
