/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package tools.descartes.dml.mm.deployment;

import org.eclipse.emf.common.util.EList;

import tools.descartes.dml.core.Entity;

import tools.descartes.dml.mm.applicationlevel.repository.Service;

import tools.descartes.dml.mm.resourcelandscape.Container;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Strategy</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dml.mm.deployment.DeploymentStrategy#getResourceContainers <em>Resource Containers</em>}</li>
 *   <li>{@link tools.descartes.dml.mm.deployment.DeploymentStrategy#getService <em>Service</em>}</li>
 *   <li>{@link tools.descartes.dml.mm.deployment.DeploymentStrategy#getDeployment <em>Deployment</em>}</li>
 * </ul>
 *
 * @see tools.descartes.dml.mm.deployment.DeploymentPackage#getDeploymentStrategy()
 * @model
 * @generated
 */
public interface DeploymentStrategy extends Entity {
	/**
	 * Returns the value of the '<em><b>Service</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Service</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Service</em>' reference.
	 * @see #setService(Service)
	 * @see tools.descartes.dml.mm.deployment.DeploymentPackage#getDeploymentStrategy_Service()
	 * @model required="true"
	 * @generated
	 */
	Service getService();

	/**
	 * Sets the value of the '{@link tools.descartes.dml.mm.deployment.DeploymentStrategy#getService <em>Service</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Service</em>' reference.
	 * @see #getService()
	 * @generated
	 */
	void setService(Service value);

	/**
	 * Returns the value of the '<em><b>Resource Containers</b></em>' reference list.
	 * The list contents are of type {@link tools.descartes.dml.mm.resourcelandscape.Container}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Resource Containers</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Resource Containers</em>' reference list.
	 * @see tools.descartes.dml.mm.deployment.DeploymentPackage#getDeploymentStrategy_ResourceContainers()
	 * @model required="true"
	 * @generated
	 */
	EList<Container> getResourceContainers();

	/**
	 * Returns the value of the '<em><b>Deployment</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link tools.descartes.dml.mm.deployment.Deployment#getDeploymentStrategies <em>Deployment Strategies</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Deployment</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Deployment</em>' container reference.
	 * @see #setDeployment(Deployment)
	 * @see tools.descartes.dml.mm.deployment.DeploymentPackage#getDeploymentStrategy_Deployment()
	 * @see tools.descartes.dml.mm.deployment.Deployment#getDeploymentStrategies
	 * @model opposite="deploymentStrategies" required="true" transient="false" ordered="false"
	 * @generated
	 */
	Deployment getDeployment();

	/**
	 * Sets the value of the '{@link tools.descartes.dml.mm.deployment.DeploymentStrategy#getDeployment <em>Deployment</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Deployment</em>' container reference.
	 * @see #getDeployment()
	 * @generated
	 */
	void setDeployment(Deployment value);

} // DeploymentStrategy
